//---------------------------------------------------------------------------


#pragma hdrstop

#include "bench.h"

//---------------------------------------------------------------------------
Object *Bench::get_object(MStr nof,MStr noo)
{
  try
  {
    // cout << "Lexical initialization \n";
    l.init(nof.c_str());
  }
  catch(...)
  {
#ifdef winapi
    Application->MessageBox("Cannot open input file","error",MB_OK);
#else
    cout << "Cannot open input file.\n";
#endif
  }

  MStr s;
  if(noo=="")
  {
    s=nof;
    int k=s.find('.');
    k++;
    if(!k || k==1) s="DefaultName";
    else
    {
      s=s.SubString(1,k-1);
    }
  }
  token=l.NextToken();
  //   form_main->RichEdit1->Lines->Add(MStr(token));
  o=new Object;
  o->name = noo;
  if(noo == "")
  {
    int k;
    if((k=nof.find('.')) == -1)
      o->name = nof;
    else
      o->name = nof.substr(0,k);
   // cout << "Object name: " << o->name << endl; 
  }
  try
  {
    CurrentGateNumber = 0;
    start();
    // cout << "Number of gates: " << CurrentGateNumber << endl; 
    if(token!=LEX_NULL) error();
  }
  catch(std::runtime_error &e)
  {
#ifdef winapi
    Application->MessageBox(e.what(),"error",MB_OK);
#else
    cout << "error occured: " << e.what() << endl;
#endif
  }
  catch(std::exception &e)
  {
    MStr s="unknown error\n"+MStr(e.what());
#ifdef winapi
    Application->MessageBox(s.c_str(),"error",MB_OK);
#else
    cout << "unknown error: " << e.what() << endl;
#endif
  }
  return o;
}

void Bench::start()
{
   inputs();
   outputs();
   assigns();
}
void Bench::inputs()
{
   if(token==LEX_INPUT) // Outputs -> OUTPUT ( IDENT ) Outputs
   {
      token=l.NextToken();
      if(token==LEX_LPA)
      {
         token=l.NextToken();
         if(token==LEX_IDENT)
         {
            Port *p=o->addPort(1,l.Lex_AStr);    // object #2
            Wire *w=o->addPRef(p,l.Lex_AStr);    // object #2
            p->wire_down=w;                      // object #2
            token=l.NextToken();
            if(token==LEX_RPA)
            {
               token=l.NextToken();
               inputs();
            }
            else
            {
               error();
            }
         }
         else
         {
            error();
         }
      }
      else
      {
         error();
      }
   }
   else return; // Inputs -> e
}
void Bench::outputs()
{
   if(token==LEX_OUTPUT) // Outputs -> OUTPUT ( IDENT ) Outputs
   {
      token=l.NextToken();
      if(token==LEX_LPA)
      {
         token=l.NextToken();
         if(token==LEX_IDENT)
         {
            Port *p=o->addPort(2,l.Lex_AStr);     // object #3
            Wire *w=o->addPRef(p,l.Lex_AStr);     // object #3
            p->wire_down=w;                       // object #3
            token=l.NextToken();
            if(token==LEX_RPA)
            {
               token=l.NextToken();
               outputs();
            }
            else
            {
               error();
            }
         }
         else
         {
            error();
         }
      }
      else
      {
         error();
      }
   }
   else return; // Outputs -> e
}
void Bench::assigns()
{
   if(token==LEX_IDENT) // Assigns -> IDENT ASSIGN Hradlo Assigns
   {
      Object *to=o->addObject("Gate_"+MStr(++CurrentGateNumber));    // object #9
      Port *p=to->addPort(2,l.Lex_AStr);   // object #9
      Wire *w=o->addPRef(p,l.Lex_AStr);     // object #7
      p->wire_up=w;                        // object #9
      p->name="O";
      token=l.NextToken();
      if(token==LEX_ASSIGN)
      {
         list<MStr> loi;       // object #5
         token=l.NextToken();
         MStr eval_param;
         hradlo(&loi,eval_param);
         to->eval_param=eval_param;   // object #5
         for(list<MStr>::iterator i=loi.begin();i!=loi.end();i++) // object #5
         {
            Port *p=to->addPort(1,*i);              // object #5
            if(to->eval_param == "DFF") p->name = "D";
            Wire *w=o->addPRef(p,*i);               // object #5
            p->wire_up=w;                           // object #5
//            o->addPRef(to->addPort(1,*i),*i);     // object #5
         }
         assigns();
      }
      else
      {
         error();
      }
   }
   else return; // Assigns -> e
}
int Bench::hradlo(list<MStr> *loi,MStr &eval_param)
{
   int id=0;
   switch(token)
   {
    case LEX_AND:
      eval_param="AND";
      break;
    case LEX_NAND:
      eval_param="NAND";
      break;
    case LEX_OR:
      eval_param="OR";
      break;
    case LEX_NOR:
      eval_param="NOR";
      break;
    case LEX_XOR:
      eval_param="XOR";
      break;
    case LEX_XNOR:
      eval_param="XNOR";
      break;
    case LEX_BUFF:
      eval_param="BUFF";
      break;
    case LEX_NOT:
      eval_param="NOT";
      break;
    case LEX_DFF:
      eval_param="DFF";
      break;
    default:
      error();
   }
   token=l.NextToken();
   if(token==LEX_LPA)
   {
      token=l.NextToken();
      idents(loi);
      if(token==LEX_RPA)
      {
         token=l.NextToken();
      }
      else
      {
         error();
      }
   }
   else
   {
      error();
   }
   if((id==8 || id==9)&& loi->size()!=1) error();
   return id;
}
void Bench::idents(list<MStr> *loi)
{
   if(token==LEX_IDENT) // Idents -> IDENT R_O_Idents
   {
      loi->push_back(l.Lex_AStr);
      token=l.NextToken();
      r_o_idents(loi);
   }
   else
   {
      error();
   }
}

void Bench::r_o_idents(list<MStr> *loi)
{
   if(token==LEX_COMMA) // R_O_Idents -> , IDENT R_O_Idents
   {
      token=l.NextToken();
      if(token==LEX_IDENT)
      {
         loi->push_back(l.Lex_AStr);
         token=l.NextToken();
         r_o_idents(loi);
      }
      else
      {
         error();
      }

   }
   else return; // R_O_Idents -> e
}
void Bench::error()
{
//   form_main->RichEdit1->Lines->Add("Error on the line "+MStr(l.rowcount));
   throw std::runtime_error(("Error on the line "+MStr(l.rowcount)).c_str());
}




//---------------------------------------------------------------------------

#pragma package(smart_init)

