//---------------------------------------------------------------------------


#pragma hdrstop

#include "device.h"
#include <fstream>



int Compare(Object *o1,Object *o2)
{
   if(o1->ordinal_number <  o2->ordinal_number) return -1;
   return 0;
   /*   if(o1->ordinal_number == o2->ordinal_number) return 0;
   if(o1->ordinal_number >  o2->ordinal_number) return 1; */
}

Wire *Object::find_wire(MStr name)
{
  map<MStr,Wire *>::iterator pr=wires.find(name);
  if(pr == wires.end()) return 0;
  else return pr->second;
}
Object *Object::addObject(const MStr &ObjectName)
{
   Object *o=new Object;
   objects.insert(pair<MStr,Object *>(ObjectName,o));
   o->name = ObjectName;
   return o;
}
Wire *Object::addWire(MStr name)
{
   Wire *w=new Wire(name);
   wires.insert(pair<MStr,Wire *>(name,w));
   return w;
}
Port *Object::addPort(int flags,MStr name)
{
   Port *p=new Port(flags,name,this);
   if(flags&1) InputPorts.push_back(p);
   if(flags&2) OutputPorts.push_back(p);
   return p;
}

void Object::eval(int XX)
{
  bool a,b,x;
  a=true;
  b=false;
  bool val;
  for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
  {
    val=(*i)->wire_up->value;
    if(eval_param=="DFF" && (*i)->wire_up->BackedUp)
      val=(*i)->wire_up->OldValue;
    else
    x=a^val;
    a=a && val;
    b=b || val;
  }
  for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
  {
    Wire *WU=(*i)->wire_up;
//    Wire *WD=(*i)->wire_down;

    if(!ordinal_number)
    {
//      Port *I=findOPort();
      WU->OldValue=WU->value;
      WU->BackedUp = true;
    }
    if (eval_param=="NAND")
       (*i)->wire_up->value=!a;
    else if (eval_param=="AND")
       (*i)->wire_up->value=a;
    else if (eval_param=="NOR" || eval_param=="NOT")
       (*i)->wire_up->value=!b;
    else if (eval_param=="OR" || eval_param == "BUFF")
       (*i)->wire_up->value=b;
    else if (eval_param=="DFF")
    {
      if(AdditionalParameter1 && ((pair<bool,int> *)AdditionalParameter1)->first)
      {
        int k = ((pair<bool,int> *)AdditionalParameter1)->second;
        (*i)->wire_up->value = ((pair<bool,int> *)AdditionalParameter1)->second;
        ((pair<bool,int> *)AdditionalParameter1)->first = false;
      }
      else
        (*i)->wire_up->value=b;
    }
    else if (eval_param=="XOR")
       (*i)->wire_up->value=x;
    else if (eval_param=="XNOR")
       (*i)->wire_up->value=!x;
    else if(eval_param.SubString(1,3)=="LUT")
    {
       int ep=getLutEvalParam(eval_param.substr(6,100));
       int pp=getLutPortParam();
       int k=1;
       k<<=pp;
       (*i)->wire_up->value=k&ep?1:0;
    }
    else if(eval_param=="GND")
    {
       (*i)->wire_up->value=false;
    }
    else if(eval_param=="DC")
    {
       (*i)->wire_up->value=true;
    }
    else if(eval_param=="INV")
    {
       (*i)->wire_up->value=!a;
    }
    else if(eval_param=="MUXF5" || eval_param=="MUXF6")
    {
       Port *p=findPort("S");
       if(!p) throw "error in MUX";
       if(p->wire_up->value)
          (*i)->wire_up->value=findPort("I1")->wire_up->value;
       else
          (*i)->wire_up->value=findPort("I0")->wire_up->value;
    }
    else if(eval_param=="MUX2")
    {
       Port *p=findPort("sel");
       if(!p) throw "error in MUX";
       if(p->wire_up->value)
          (*i)->wire_up->value=findPort("in1")->wire_up->value;
       else
          (*i)->wire_up->value=findPort("in0")->wire_up->value;
    }
    else
    {
       for(list<Port *>::iterator it=InputPorts.begin();it!=InputPorts.end();it++)
       {
          Wire *w=(*it)->wire_down;
          w->OldValue = w->value;
          w->value = (*it)->wire_up->value;
       }

       eval();
       for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
       {
          if((*i)->inoutflags&2)
             (*i)->wire_up->value = (*i)->wire_down->value;
       }
       break;
    }
  }
  return;
}

void Object::evalMV(int XX)
{
  int a,b,x;
  a=1;
  b=0;
  bool val;
  for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
  {
    val=(*i)->wire_up->value;
    if(eval_param=="DFF" && (*i)->wire_up->BackedUp)
      val=(*i)->wire_up->OldValue;
    else
    x=ValueType->mXor(a,val);
    a=ValueType->mAnd(a,val);
    b=ValueType->mOr(b,val);
  }
  for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
  {
    Wire *WU=(*i)->wire_up;
    Wire *WD=(*i)->wire_down;

    if(!ordinal_number)
    {
//      Port *I=findOPort();
      WU->OldValue=WU->value;
      WU->BackedUp = true;
    }


    if (eval_param=="NAND")
       (*i)->wire_up->value=ValueType->mNot(a);
    else if (eval_param=="AND")
       (*i)->wire_up->value=a;
    else if (eval_param=="NOR" || eval_param=="NOT" || eval_param=="INV")
       (*i)->wire_up->value=ValueType->mNot(b);
    else if (eval_param=="OR" || eval_param=="DFF" || eval_param == "BUFF")
       (*i)->wire_up->value=b;
    else if (eval_param=="XOR")
       (*i)->wire_up->value=x;
    else if (eval_param=="XNOR")
       (*i)->wire_up->value=ValueType->mNot(x);
    else if(eval_param.SubString(1,3)=="LUT")
    {
      throw "LUTs not suppoted in multivalued objects";
       int ep=getLutEvalParam(eval_param.substr(6,100));
       int pp=getLutPortParam();
       int k=1;
       k<<=pp;
       (*i)->wire_up->value=k&ep;
    }
    else if(eval_param=="GND")
    {
       (*i)->wire_up->value=0;
    }
    else if(eval_param=="MUXF5" || eval_param=="MUXF6")
    {
       Port *p=findPort("S");
       if(!p) throw "error in MUX";
       if(p->wire_up->value)
          (*i)->wire_up->value=findPort("I1")->wire_up->value;
       else
          (*i)->wire_up->value=findPort("I0")->wire_up->value;
    }
    else if(eval_param=="MUX2")
    {
       Port *p=findPort("sel");
       if(!p) throw "error in MUX";
       if(p->wire_up->value)
          (*i)->wire_up->value=findPort("in1")->wire_up->value;
       else
          (*i)->wire_up->value=findPort("in0")->wire_up->value;
    }
    else
    {
       for(list<Port *>::iterator it=InputPorts.begin();it!=InputPorts.end();it++)
       {
          Wire *w=(*it)->wire_down;
          w->OldValue = w->value;
          w->value = (*it)->wire_up->value;
       }

       eval();
       for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
       {
          if((*i)->inoutflags&2)
             (*i)->wire_up->value = (*i)->wire_down->value;
       }
       break;
    }
  }
  return;


}


void Object::eval()
{
  if(eval_param.substr(0,3) == "PLA")
  {
    evalPLA();
    return;
  }
  getOrdinalNumbers();
  ClearBackedUps();
  for(list<Object *>::iterator o=SortedObjects.begin();o!=SortedObjects.end();o++)
  {
     MStr bv=(*o)->eval_param;
     (*o)->eval(0);;
  }
}

void Object::evalPLA()
{
  int type;
  int b=OutputPorts.size();
  int *out=new int[b];
  if(eval_param.substr(4,2)=="fd" || eval_param.substr(4,1)=="f")
  {
    type = 0;
    memset(out,0,b*sizeof(int));
  }
  if(eval_param.substr(4,2)=="fr")
  {
    type = 2;
    memset(out,2,b*sizeof(int));
  }
  MStr in="";
  for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
  {
    int val=(*i)->wire_down->value;
    in += MStr(val);
  }

  list<pair<string,string> > *l=(list<pair<string,string> > *)AdditionalParameter1;
  int h = l->size();

  for(list<pair<string,string> >::iterator i=l->begin();i!=l->end();i++)
  {
    string &l1=i->first;
    string &l2=i->second;
    int a=InputPorts.size();

    bool status=true;
    for(int j=0;j<a;j++)
    {
      if(in[j] != l1[j] && l1[j] != '-')
      {
        status = false;
        break;
      }
    }
    if(status && type==0)
      for(int j=0;j<b;j++)
      {
        if(l2[j] == '-' || l2[j] == '2')
          out[j] = 2;
        if(l2[j] == '1' && out[j] != 2)
          out[j] = 1;
      }
    if(status && type==2)
      for(int j=0;j<b;j++)
      {
        if(l2[j] == '0')
          if(out[j] != 1)
            out[j] =0;
          else throw "wrong PLA";
        if(l2[j] == '1')
          if(out[j] != 0)
            out[j] = 1;
          else throw "wrong PLA";
      }
  }
  int *c=out;
  for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++,c++)
  {
    (*i)->wire_down->value = *c;
  }
}

Wire *Object::addPRef(Port *p,MStr name)
{
   Wire *w=find_wire(name);
   if(w==0) w=addWire(name);
   w->prefs.push_back(p);
   if(p->object == this)
     p->wire_down = w;
   else
     p->wire_up = w;
   return w;
}
Wire *Object::addPRef(Port *p,Wire *w) // pid ukazatel;
{
   if(w==0) return 0;
   w->prefs.push_back(p);
   if(p->object == this)
     p->wire_down = w;
   else
     p->wire_up = w;
   return w;
}

void Object::saveBench(MStr nof)
{
  benchLikeDFFPorts();
  benchLikeWireNames();
  if(nof == "") nof="output";
  fstream of(nof.c_str(),ios::out);
  for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
   of << "INPUT(" << (*i)->name.c_str() << ")" << endl;
  for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
   of << "OUTPUT(" << (*i)->name.c_str() << ")" << endl;
  for(map<MStr,Wire *>::iterator i1=wires.begin();i1!=wires.end();i1++)
  {
    for(list<Port *>::iterator i2=i1->second->prefs.begin();i2!=i1->second->prefs.end();i2++)
    {
      if((*i2)->object==this) continue;
      if(((*i2)->inoutflags&2)==2)
      {
      //            of << (*i2)->name.c_str() << " = ";
        of << (*i2)->wire_up->name.c_str() << " = ";
        MStr s=((*i2)->object->eval_param+"(").c_str();
        for(list<Port *>::iterator i3=(*i2)->object->InputPorts.begin();i3!=(*i2)->object->InputPorts.end();i3++)
          s+=(*i3)->wire_up->name+",";
        if(s[s.length()-1]==',')
          s.resize(s.length()-1);
        s+=")";
        of << s.c_str() << endl;
      }
    }
  }
   of.close();
}

void Object::saveCir(MStr nof)
{
  if(nof == "") nof="output";
  fstream of(nof.c_str(),ios::out);

  of << "Circuit " << name.c_str() << ";" << endl << endl;
  of << "Node" << endl;
  for(map<MStr,Wire *>::iterator i=wires.begin();i!=wires.end();)
  {
    of << "  " << i->second->name;
    if(++i!=wires.end()) of << ",";
  }
  of << " : bit;" << endl << endl;
  of << "Con (delay:10)" << endl;

  for(map<MStr,Object *>::iterator i=objects.begin();i!=objects.end();i++)
    of << "  " <<i->second->name << " : " << i->second->eval_param.LowerCase() << "_" << i->second->InputPorts.size() << ";" << endl;

  of << endl << "Input" << endl << "  ";
  for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();)
  {
    of << (*i)->name.c_str();
    if(++i!=InputPorts.end()) of << ",";
  }
  of << ";" << endl << endl;

  of << "Output" << endl << "  ";
  for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();)
  {
    of << (*i)->name.c_str();
    if(++i!=OutputPorts.end()) of << ",";
  }
  of << ";" << endl << endl;

  of << "Strobe" << endl;
  of << " STROBEALL : " << endl;
  of << "  ";
  for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();)
  {
    of << (*i)->name.c_str();
    if(++i!=OutputPorts.end()) of << ",";
  }
  of << ";" << endl << endl;

  of << "begin" << endl;
  for(map<MStr,Object *>::iterator i=objects.begin();i!=objects.end();i++)
  {
    of << "  " <<i->second->name.c_str() << "(";
    for(list<Port *>::iterator j=i->second->InputPorts.begin();j!=i->second->InputPorts.end();)
    {
      of << (*j)->wire_up->name.c_str();
      if(++j!=i->second->InputPorts.end()) of << ",";
    }
    of << ";";
    of << i->second->findOPort()->wire_up->name.c_str() << ");" << endl;
  }
  of << "end." << endl;
  of.close();
}

void Object::get_ports(int &inputs,int &outputs)
{
   inputs=InputPorts.size();
   outputs=OutputPorts.size();
}

Object *Object::findObject(const MStr &ObjectName)
{
  map<MStr,Object *>::iterator pr=objects.find(ObjectName);
  if(pr == objects.end()) return 0;
  else return pr->second;
}
Port *Object::findPort(const MStr &PortName)
{
   for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
      if((*i)->name==PortName) return *i;
   for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
      if((*i)->name==PortName) return *i;
   return 0;
}
int Object::getLutEvalParam(MStr InitMStr)
{
   int r;
   sscanf(InitMStr.c_str(),"%X",&r);
   return r;
}

int Object::getLutPortParam()
{
  int r=0,d=1;
  for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
  {
    if((*i)->wire_up->value) r+=d;
    d<<=1;
  }
  return r;
}
int Object::getOrdinalNumbers()
{
   static int c;
   if(on_zjisteno) return c;
   list<pair<Wire *,Port *> > dv;
   for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
   {
      MStr p = (*i)->name;
      dv.push_back(pair<Wire *,Port *>((*i)->wire_down,(*i)));
   }
   for(map<MStr,Object *>::iterator i=objects.begin();i!=objects.end();i++)
   {
      if(i->second->eval_param != "DFF") continue;
      for(list<Port *>::iterator j=i->second->InputPorts.begin();j!=i->second->InputPorts.end();j++)
      {
         for(list<Port *>::iterator k=(*j)->wire_up->prefs.begin();k!=(*j)->wire_up->prefs.end();k++)
         {
            if(((*k)->inoutflags&1)==1) continue;
            if((*k)->object==this) continue;
            dv.push_back(pair<Wire *,Port *>((*k)->wire_up,(*k)));
            break;
         }
      }
   }
   c=0;
   list<pair<Wire *,Port *> > dv2;
   while(true)    //zjitn ordinal_number vech objekt
   {
      int ex=0;
      for(list<pair<Wire *,Port *> >::iterator i=dv.begin();i!=dv.end();i++)
      {
         MStr n=i->first->name;
         MStr p=i->second->name;
         for(list<Port *>::iterator j=i->first->prefs.begin();j!=i->first->prefs.end();j++)
         {
            if(*j==i->second) continue;  // kdy je to port z dvojice dv
            if((*j)->object==this) continue;  // kdy pat tomuto objektu
            if((*j)->object->eval_param == "DFF" && c != 0) continue;
            (*j)->object->ordinal_number=c;  // kdy jinmu, pia ordinal number
            MStr ep=(*j)->object->eval_param;
            for(list<Port *>::iterator k=(*j)->object->OutputPorts.begin();k!=(*j)->object->OutputPorts.end();k++)
            {  // pro kad vstupn port pidej dvojici do novho seznamu
               dv2.remove(pair<Wire *,Port *>((*k)->wire_up,(*k))); // odstra duplicity
               dv2.push_back(pair<Wire *,Port *>((*k)->wire_up,(*k)));
               ex++;
            }
         }
      }
      if(!ex) break;
      c++;
      dv=dv2;
      dv2.clear();
   }
  SortedObjects.clear();
  for(map<MStr,Object *>::iterator i=objects.begin();i!=objects.end();i++)
  {
    SortedObjects.push_back(i->second);
  }
  SortedObjects.sort(Compare);
  on_zjisteno = true;
  return c;
}

Object *Object::copy()
{
   Object *o=new Object(ValueType);
   o->eval_param=eval_param;
   o->name=name;
   o->ordinal_number=ordinal_number;
   for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
   {
      if(!((*i)->inoutflags&1)) throw "xd";
      o->addPort((*i)->inoutflags,(*i)->name);
   }
   for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
   {
      if(!((*i)->inoutflags&2)) throw "dx";
      o->addPort((*i)->inoutflags,(*i)->name);
   }

//   if(eval_param!="")
//   {
//      return o;
//   }

   for(map<MStr,Object *>::iterator i=objects.begin();i!=objects.end();i++)
      o->objects.insert(pair<MStr,Object *>(i->first,i->second->copy()));
   for(map<MStr,Wire *>::iterator w=wires.begin();w!=wires.end();w++)
      for(list<Port *>::iterator p=w->second->prefs.begin();p!=w->second->prefs.end();p++)
         if((*p)->object==this)
         {
            Port *p1=o->findPort((*p)->name);
            Wire *w1=o->addPRef(p1,w->second->name);
            p1->wire_down=w1;
         }
         else
         {
            Object *obj=o->findObject((*p)->object->name);
            Port *p1=obj->findPort((*p)->name);
            Wire *w1=o->addPRef(p1,w->second->name);
            p1->wire_up=w1;
         }
   return o;

}

Port *Object::findOPort()
{
   for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
     return *i;
   return 0;
}

void Object::ClearBackedUps()
{
  for(map<MStr,Object *>::iterator i=objects.begin();i!=objects.end();i++)
  if(!(i->second->ordinal_number))
    i->second->findOPort()->wire_up->BackedUp = false;
}

void Object::benchLikeDFFPorts()
{
  if(evaluationDefined(eval_param)) return;
  for(map<MStr,Object *>::iterator i=objects.begin();i!=objects.end();i++)
    i->second->benchLikeDFFPorts();
  for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
  {
    bool toberemoved =false;
    Wire *w=(*i)->wire_down;
    if(!w) throw (string(eval_param)+" "+name).c_str();
    for(list<Port *>::iterator it=w->prefs.begin();it!=w->prefs.end();it++)
    {
      if((*it)->object == this) continue;
      if((*it)->object->eval_param != "DFF") continue;
      if((*it)->name == "D") continue;
      toberemoved =true;
      break;
    }
    if(toberemoved)
    {
      for(list<Port *>::iterator it=w->prefs.begin();it!=w->prefs.end();it++)
      {
        Object *o=(*it)->object;
        Port *p=(*it);
        if(o==this && p->wire_up)
          p->wire_up->prefs.remove(p);
        if(o==this)
          i--;
        o->InputPorts.remove(p);
        delete p;
      }
      wires.erase(w->name);
      delete w;
    }
  }
}

bool Object::evaluationDefined(const MStr&s)
{
  if(s=="NAND" || s=="AND" || s=="NOR" || s=="NOT" || s=="OR" || s=="DFF" ||
    s=="BUFF" || s=="XOR" || s=="XNOR" || s=="LUT" || s=="GND" || s=="DC" ||
    s=="INV" || s=="MUXF5" || s=="MUXF6" || s=="MUX2")
    return true;
  else return false;
}

void Object::benchLikeWireNames()
{
  int c=0,d=0;
  for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
  {
    bool joinsOP=false;
    for(list<Port *>::iterator j=(*i)->wire_down->prefs.begin();j!=(*i)->wire_down->prefs.end();j++)
    {
      if((*j)==(*i)) continue;
      if((*j)->object==this)
      {
        joinsOP=true;
        break;
      }
    }
    if(joinsOP)
    {
      for(list<Port *>::iterator j=(*i)->wire_down->prefs.begin();j!=(*i)->wire_down->prefs.end();j++)
      {
        if((*j)==(*i)) continue;
        if((*j)->object!=this) continue;
        Object *b=addObject(MStr("tempBuff_")+MStr(c++));
        b->eval_param="BUFF";
        Port *ip=b->addPort(1,"I");
        addPRef(ip,(*i)->wire_down);
        Port *op=b->addPort(2,"O");
        Wire *w=addWire(MStr("tempWire_")+MStr(d++));
        addPRef(op,w);
        addPRef((*j),w);
        Port *j2=*j--;
        (*i)->wire_down->prefs.remove(j2);
      }
    }
    if((*i)->name != (*i)->wire_down->name)
    {
      wires.erase((*i)->wire_down->name);
      wires.insert(pair<MStr,Wire *>((*i)->name,(*i)->wire_down));
      (*i)->wire_down->name = (*i)->name;
    }
  }
  for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
  {
    if((*i)->name != (*i)->wire_down->name)
    {
      wires.erase((*i)->wire_down->name);
      wires.insert(pair<MStr,Wire *>((*i)->name,(*i)->wire_down));
      (*i)->wire_down->name = (*i)->name;
    }
  }
}


Object::~Object() {
    if(eval_param == "PLA")
    {
      delete (list<pair<string,string> > *)AdditionalParameter1;
      delete[] (char *)AdditionalParameter2;
    }
    if(eval_param == "DFF")
    {
      delete (pair<bool,int> *)AdditionalParameter1;
    }
    delete ValueType;
    for(map<MStr,Object *>::iterator j=objects.begin();j!=objects.end();j++)
      delete j->second;
    for(list<Port *>::iterator i=InputPorts.begin();i!=InputPorts.end();i++)
      delete *i;
    for(list<Port *>::iterator i=OutputPorts.begin();i!=OutputPorts.end();i++)
      delete *i;
    for(map<MStr,Wire *>::iterator k=wires.begin();k!=wires.end();k++)
      delete k->second;
}

//---------------------------------------------------------------------------

#pragma package(smart_init)


