#include <iostream>
#include <iomanip>
#include <string>
#include <ostream>
#include "debug.h"

#ifndef logic4_h 
#define logic4_h

// debugging macros

#define PinN 4
#define BUFS 4

extern int globalPINS;
extern int dbg_print;

using namespace std;

class logic4 {
	int *val1,*val2; // 2 values combination 
	int size,bits;
public:
	logic4() {
		val1=NULL;
		val2=NULL;
		bits=0;
		size=0;
	}
	logic4(int x)
	{ 
		if (x>0) {
		size=(x-1)/(8*sizeof(int))+1;
		bits=x;
		DBG_Cout("bits:=" << bits <<endl);
		val1=new int[size];
		val2=new int[size];
		} else
		{
		val1=NULL;
		val2=NULL;
		bits=0;
		size=0;
		}
	}
	
	logic4& operator|(logic4 &lr) { 
		logic4 *pom;
		if(bits==lr.bits) {
		 pom=new logic4(bits);
		 for(int i=0;(i<size)&&(i<lr.size);i++) {
			pom->val1[i]=(val1[i]|lr.val1[i]); 
			pom->val2[i]=(val2[i]|lr.val2[i]); 
		 } } 
		 else pom=new logic4;
		 return *pom;
	}

	int isEmpty() {;
		for(int i=0;(i<size);i++) {
			if (val2[i]&val1[i]) return 1;
		}
		return (bits==0);
	}

	logic4& setPIN(int bit,int val) { // -1(X),0,1,2(Z) ! destructive
		int setted=val+1;
		int pos=bit/(8*sizeof(int));
		int ipos=bit%(8*sizeof(int));
		int lower=(setted&1);
		int upper=(setted&2)>>1;
		this->val1[pos]=upper<<ipos; 
		this->val2[pos]=lower<<ipos; 
		return *this;
	}

	logic4& operator=(logic4 &lr) { 
	  if (lr.size>0) {
		if (val1!=NULL) delete [] val1;
		if (val2!=NULL) delete [] val2;
		bits=lr.bits;
		size=lr.size;
		val1=new int[size];
		val2=new int[size];
		for(int i=0;(i<size);i++) {
			DBG2_Cout( "in=" << i << endl,3);
			DBG2_Cout( "v1=" << lr.val1[i] << endl,3);
			DBG2_Cout( "v2=" << lr.val2[i] << endl,3);
			val1[i]=lr.val1[i]; 
			val2[i]=lr.val2[i]; 
		}
	  } else DBG2_Cout( "??" <<endl,3);
		return *this;
	}

	int operator==(logic4 &lr) { 
	  if (lr.size>0) {
		int ok=1;
		ok=(bits==lr.bits)&&(size==lr.size);
		for(int i=0;(i<size)&&ok;i++) {
			ok=((val1[i]==lr.val1[i])&&(val2[i]==lr.val2[i]));
		}
		return ok;
	  } 
		return (size==lr.size);
	}

	friend ostream& operator<< ( ostream& theStream,logic4 &l) {
		int j=0,k,m,b;
		DBG2_Cout( "bits" << l.bits << endl,2);
		for(int i=0;i<l.size;i++) {
			k=l.val1[i];
			m=l.val2[i];
			for(b=0;(j<l.bits)&&(b<8*sizeof(int));j++,b++) {
			//	DBG_Cout << "j=" << j << endl;
				if ((k&1)!=(m&1)) theStream << (k&1);
				else if (k&1) theStream << "Z" ;
				     else theStream << "X";
				k>>=1;
				m>>=1;
			}
		}
		// theStream << "X=" << l.x << endl;
		// theStream;
		return theStream;
	}
};

class logicRec {
	logic4 l4;
	logicRec *next;
	int rank,rbuf;
public:
	logicRec() { next=NULL; rank=-1; rbuf=BUFS; }
	~logicRec();
	logicRec(logic4& l) { next=NULL; l4=l; rank=-1; rbuf=BUFS; }
	logicRec(logic4& l,int r) { next=NULL; l4=l; rank=r; rbuf=BUFS;  }
	int isEmpty() { return (next==NULL); }
	void print();
	int getRank() { return rank; }
	logicRec& getFrom(int r);
	logicRec& logicRec::select(int x);
	int Has(logic4& l);
	void Add(logic4& l); 
	void delRec();
	logicRec& operator&(logicRec lr);
	logicRec& operator|(logicRec lr);
};


class logic4Set {
	logicRec Sets;
	int rank, rbuf;
public:
	logic4Set() { rank=0; rbuf=BUFS; }; // Sets=new logicRec; }
	~logic4Set();
	logic4Set(int pins);
	logicRec getSets() { return Sets; };
	logicRec setSets(logicRec &S) { Sets=S; };
	void makePIN(int pin,int val);
	void print();
	int getRank() { return rank; }
	int isEmpty();
	void delSet();
	logic4Set& getFrom(int r);
	logic4Set& selection(int x);
	logic4Set& operator*(logic4Set lr); // prunik mnozin
	logic4Set& operator+(logic4Set lr); // sjednoceni mnozin
};


#endif 

