#include <iostream>
#include <iomanip>
#include <string>
#include <ostream>

#ifndef logic4_h 
#define logic4_h

#define PinN 4
#define DBG_Cout if (0) cout  

int globalPINS;

using namespace std;

class logic4 {
	int *val1,*val2; // 2 values combination 
	int size,bits;
public:
	logic4() {
		val1=NULL;
		val2=NULL;
		bits=0;
		size=0;
	}
	logic4(int x)
	{ 
		if (x>0) {
		size=(x-1)/(8*sizeof(int))+1;
		bits=x;
		DBG_Cout << "bits:=" << bits <<endl;
		val1=new int[size];
		val2=new int[size];
		} else
		{
		val1=NULL;
		val2=NULL;
		bits=0;
		size=0;
		}
	}
	
	logic4& operator|(logic4 &lr) { 
		logic4 *pom;
		if(bits==lr.bits) {
		 pom=new logic4(bits);
		 for(int i=0;(i<size)&&(i<lr.size);i++) {
			pom->val1[i]=(val1[i]|lr.val1[i]); 
			pom->val2[i]=(val2[i]|lr.val2[i]); 
		 } } 
		 else pom=new logic4;
		 return *pom;
	}

	int isEmpty() {;
		for(int i=0;(i<size);i++) {
			if (val2[i]&val1[i]) return 1;
		}
		return (bits==0);
	}

	logic4& setPIN(int bit,int val) { // -1(X),0,1,2(Z) ! destructive
		int setted=val+1;
		int pos=bit/(8*sizeof(int));
		int ipos=bit%(8*sizeof(int));
		int lower=(setted&1);
		int upper=(setted&2)>>1;
		this->val1[pos]=upper<<ipos; 
		this->val2[pos]=lower<<ipos; 
		return *this;
	}

	logic4& operator=(logic4 &lr) { 
	  if (lr.size>0) {
		if (val1!=NULL) delete [] val1;
		if (val2!=NULL) delete [] val2;
		bits=lr.bits;
		size=lr.size;
		val1=new int[size];
		val2=new int[size];
		for(int i=0;(i<size);i++) {
			/*
			 DBG_Cout << "in=" << i << endl;
			 DBG_Cout << "v1=" << lr.val1[i] << endl;
			 DBG_Cout << "v2=" << lr.val2[i] << endl;
			 */
			val1[i]=lr.val1[i]; 
			val2[i]=lr.val2[i]; 
		}
	  } // else DBG_Cout << "??" <<endl;
		return *this;
	}

	int operator==(logic4 &lr) { 
	  if (lr.size>0) {
		int ok=1;
		ok=(bits==lr.bits)&&(size==lr.size);
		for(int i=0;(i<size)&&ok;i++) {
			ok=((val1[i]==lr.val1[i])&&(val2[i]==lr.val2[i]));
		}
		return ok;
	  } 
		return (size==lr.size);
	}

	friend ostream& operator<< ( ostream& theStream,logic4 &l) {
		int j=0,k,m,b;
		// DBG_Cout << "bits" << l.bits << endl;
		for(int i=0;i<l.size;i++) {
			k=l.val1[i];
			m=l.val2[i];
			for(b=0;(j<l.bits)&&(b<8*sizeof(int));j++,b++) {
			//	DBG_Cout << "j=" << j << endl;
				if ((k&1)!=(m&1)) theStream << (k&1);
				else if (k&1) theStream << "Z" ;
				     else theStream << "X";
				k>>=1;
				m>>=1;
			}
		}
		// theStream << "X=" << l.x << endl;
		// theStream;
		return theStream;
	}
};

class logicRec {
	logic4 l4;
	logicRec *next;
public:
	logicRec() { next=NULL; };
	logicRec(logic4& l) { next=NULL; l4=l; }
	int isEmpty() { return (next==NULL); }
	void print();
	int Has(logic4& l);
	void Add(logic4& l) {
		logicRec *pom=new logicRec(l);
		DBG_Cout << "added:" << l <<endl;
		pom->next=next;
		next=pom;
	}
	logicRec& operator&(logicRec lr);
	logicRec& operator|(logicRec lr);
};

void logicRec::print() {
logicRec *pom;
pom=this->next;
int i=0;
DBG_Cout << "zacatek tisku"<<endl;
while(pom!=NULL) {
	i++;
	cout << "i=" << i << ", vektor:" <<  pom->l4 <<endl;
	pom=pom->next;
}
DBG_Cout << "konec tisku"<<endl;
}

logicRec& logicRec::operator|(logicRec lr) {
logicRec *pom=new logicRec;
logicRec *lRi=this->next;
logicRec *lRj=lr.next;
	while(lRi!=NULL) {
		logic4 x=(lRi->l4);
		if (!x.isEmpty()) pom->Add(x);
		lRi=lRi->next;
	}
	while(lRj!=NULL) {
		logic4 x=(lRj->l4);
		if (!x.isEmpty()&&!pom->Has(x)) pom->Add(x);
		lRj=lRj->next;
	}
return *pom;
}

int logicRec::Has(logic4& l) {
logicRec *lRi=next;
	while(lRi!=NULL) {
		if (lRi->l4==l) return 1;
		lRi=lRi->next;
	}
return 0;
}

logicRec& logicRec::operator&(logicRec lr) {
logicRec *pom=new logicRec;
logicRec *lRi=next;
logicRec *lRj;
logic4 x;
// DBG_Cout << "&:" << endl;
	while(lRi!=NULL) {
		lRj=lr.next;
		while(lRj!=NULL) {
			/*
			DBG_Cout << lRi->l4 << endl;
			DBG_Cout << lRj->l4 << endl;
			*/
			x=(lRi->l4|lRj->l4);
			if (!x.isEmpty()&&!pom->Has(x)) pom->Add(x);
			// DBG_Cout << x << endl;
			lRj=lRj->next;
		}
		lRi=lRi->next;
	}
// DBG_Cout << "&x" << endl;
return *pom;
}

class logic4Set {
	logicRec Sets;
public:
	logic4Set() { }; // Sets=new logicRec; }
	logic4Set(int pins);
	logicRec getSets() { return Sets; };
	logicRec setSets(logicRec &S) { Sets=S; };
	void makePIN(int pin,int val);
	void print();
	int isEmpty();
	logic4Set& operator*(logic4Set lr); // prunik mnozin
	logic4Set& operator+(logic4Set lr); // sjednoceni mnozin
};

int logic4Set::isEmpty() { return Sets.isEmpty(); }

void logic4Set::print() {
	DBG_Cout << "set:";
	Sets.print();
	DBG_Cout <<endl;
}

logic4Set& logic4Set::operator*(logic4Set lr) {
logic4Set *pom=new logic4Set;
pom->setSets(Sets&lr.getSets());
return *pom;
}

logic4Set& logic4Set::operator+(logic4Set lr) {
logic4Set *pom=new logic4Set;
pom->setSets(Sets|lr.getSets());
return *pom;
}

void logic4Set::makePIN(int pin,int val) {
	if (Sets.isEmpty())  {
		logic4 *l4=new logic4(globalPINS);
		l4->setPIN(pin,val);
		Sets.Add(*l4);
	}
}

logic4Set::logic4Set(int pins) {
	// Sets=new logicRec();
	globalPINS=pins;
}


#endif 

