#include "structure.h"
#include "bench.h"
#include "tables.h"


DDItem::DDItem(int in,int out) { 
// not used yet - abstract in/out structure
	inputs=in; 
	outputs=out; 
	Inputs=makeArray<DDItem*>(in);
	Outputs=makeArray<DDItem*>(out);
}


void DDFault::DDClear () { // clear faults, used in constructors
	next=NULL; 
	prev=NULL; 
	na=NULL;
	fg=NULL; 
	fw=NULL; 
	stuckAt=-1; 
	index=-1; 
	pio=0; 
	active=1; 
	domine=NULL; 
	domini=NULL; 
	ekvf=NULL; 
	found=0;
};

int DDFault::isEmpty() {
DDFault *pom=this;
// cout << pom << endl;
if (fw==NULL) active=0;
if ((pom->na!=NULL)&&(pom->na->active)) pom=pom->na;
// cout << pom << endl;
while ((pom!=NULL)&&(!pom->active)) {
// cout << pom << ":" << pom->active << endl;
	pom=pom->next;
}
na=pom;
// if (pom!=NULL) cout << pom << ":" << pom->active << endl;
if (pom!=NULL) return (!pom->active);
else return 1;
}

DDFault *DDFault::getActive() {
return na; 
}

// new fault - add into list, with previous item "pr", fault value sa, wire flw
DDFault::DDFault(DDFault *pr,int sa,DDWire *flw) { 
		DDClear();
		// cout << "now;" << next << prev << fg << fw << stuckAt << index << pio << active << endl;
	    	if (dbg_print) printf("novy fault, sa%d, fw=%p\n",sa,flw);
		stuckAt=sa;
		fw=flw;
      		prev=pr; 
		if (pr==NULL) { cerr << "vnitrni chyba\n"; exit(1); }
		if (dbg_print) cout<< "next\n"; 
      		next=pr->next; 
		if (next!=NULL) next->prev=this;
      		pr->next=this; 
      		if (sa==0) next=new DDFault(this,1,flw); 
}

// new fault - add into list, with previous item "pr", fault value sa, wire flw
DDFault::DDFault(DDFault *pr,int sa,DDGate *flg,int ind) { 
		DDClear();
		// cout << "now;" << next << prev << fg << fw << stuckAt << index << pio << active << endl;
	    	if (dbg_print) 
			printf("novy fault, i=%d sa=%d fg=%p\n",ind,sa,flg);
      		stuckAt=sa; index=ind; fg=flg; 
		if (fg!=NULL) fw=fg->inwires[ind];
		else fw=NULL;
      		prev=pr; 
		if (pr==NULL) { cerr << "vnitrni chyba\n"; exit(1); }
		if (dbg_print) cout<< "next\n"; 
      		next=pr->next; 
		if (next!=NULL) next->prev=this;
      		pr->next=this; 
      		if (sa==0) next=new DDFault(this,1,flg,ind); 
}

// ----------------WIRE----------------------

void DDWire::DDClear() { 	
		outputs=1; 
		value=vUndef;
		svalue=vUndef;
		state=pUndef; 
		fromgate=NULL;  
		togate=NULL; 
		fromwire=NULL;  
		towires=NULL;  
		FL=NULL;
		//makeArray<DDGate *>(2);
		name=strdup("-");  
	};


void DDGate::DDClear() { 
	value=vUndef;
	svalue=vUndef;
	inwires=NULL; 
	outwire=NULL; 
	gTyp=tUND; 
	name=NULL; 
	backG=NULL; 
};

// most important - gets value of input, input wire, and 
// decides the "best" wire to get first - 1->best all->worst

// get yet untested input of gate
int DDGate::getFreeInput(int i,int& nval,int &otval, int& sval,int& otsval) {
int gnot=(gTyp&tNOT);
int xory=0;
int back=vUndef;
otval=vUndef;
otsval=vUndef;
if (gnot) { if (nval>=0) nval=1-nval; if (sval>=0) sval=1-sval; }
switch (gTyp&~tNOT) {
			case tAND: if (nval>=0)  { if (nval==1) otval=1; else nval=0;  }
				   if (sval>=0) otsval=1;
					   break ;;
			case tOR: if (nval>=0) { if  (nval==0) otval=0; else nval=1; }
				  if (sval>=0) otsval=0;
					  break ;;
			case tXOR: xory=1; break;;
}

if (xory) { 
	int I0=inwires[0]->value;
	int I1=inwires[1]->value;
	int IS0=inwires[0]->svalue;
	int IS1=inwires[1]->svalue;
	DBG_Cout ("I: " << I0 <<", " << I1 <<", " << IS0 <<", " << IS1 << endl);

	otval=vUndef;
    if (i==vUndef) { // first try
	if (I0!=vUndef) { // value of 0 is set
		if (I1!=vUndef) {  // both set, correct ?
			if ((I0 xor I1)!=nval) nval=-1; 
		} else { // 1 is undef
			if (nval!=vUndef) { 
				nval=nval xor I0; // set 1v if val
	       			back=1; 
			}
			if (sval!=vUndef) {
				if (IS1!=vUndef) {
					if (sval!=(IS1 xor I0)) { sval=vUndef; nval=vUndef; }
				}
				else { sval=sval xor I0; back=1; }// set 1s if sens
			}
		} // else
	} else  // 0 is undef
	if (I1!=vUndef) { // value of 1 is set, both are checked,
			if (IS0!=vUndef) {
				if (sval!=IS0 xor I1) { nval=vUndef; sval=vUndef; } // set 0s if sens
			}
			else { sval=sval xor I1; back=0; }
			if (nval!=vUndef) { nval=nval xor I1; back=0; } // set 0v if val
	} else  // 

	if (IS0!=vUndef) {  // sens set
		if (IS1!=vUndef) { // sens x sens -> not sens
			sval=vUndef;
			if (nval!=(IS0 xor IS1)) nval=vUndef;
		}
		else { // sens x V -> SV & vv.
			if (sval!=vUndef) { nval=sval xor IS0; sval=vUndef; }
			else
			if (nval!=vUndef) { sval=nval xor IS0; nval=vUndef; }
			back=1;
		} 
	} else
	if (IS1!=vUndef) {  // sens x V -> SV & vv.
		if (sval!=vUndef) { nval=sval xor IS1; sval=vUndef; }// 0 is val then
		else 
		if (nval!=vUndef) { sval=nval xor IS1; nval=vUndef; } // 0 is sens then
		back=0;
	}
    } // end of first try
    if ((I0==I1)&&(IS0==IS1)&&(I0==IS0)&&(IS0==vUndef)) { /// !!!! nothing set !!!!
	otval=0;
	DBG_Cout( "IE: " << I0 <<", " << I1 <<", " << IS0 <<", " << IS1 << endl);
	if (i==-1) { connected=0; back=0; } // first time 0...
	if (i==0) {
		if  (connected>1) { // 2nd time 1 
			if (nval!=vUndef) { sval=1-nval; nval=vUndef; }
			connected=0;  back=1;  }
		else
		if  (connected>0) { // 1st time 1 
			connected=2;  back=0;  }
		  else {
		connected=1;
		if (nval!=vUndef) nval=1-nval; 
		if (sval!=vUndef) sval=1-sval;
		back=0; // 2nd time 0...
		  }
	}
	if (i==1) { 
		if (connected>1) back=vUndef; 
		else
		if  (connected>0) { // 2nd time 1 
			if (nval!=vUndef) { sval=nval; nval=vUndef; }
			connected=2;  back=1;  }
		else {
		 connected=1;
		 if (nval!=vUndef) nval=1-nval; 
		 if (sval!=vUndef) sval=1-sval;
		 back=1; 
		}
	} // 2nd time 1
    }
} else // end xory
{
int k;
int sensitive=0;
int full=1;
for (k=0;k<inputs;k++) { // check values 
	DBG_Cout("free k:" << k <<endl);
	if ((inwires[k]->svalue!=vUndef)&&(sval>=0)) { // cannot be both val & sval
		DBG_Cout("free s:" << inwires[k]->svalue << endl);
		if (inwires[k]->svalue!=sval) { sval=vUndef; } // 1 bad is enough
		else sensitive=1;
		if (otval>=0) { nval=vUndef; } // cannot have sensitive with all for 1 
	}
	else 
	if (inwires[k]->value!=vUndef) {
		DBG_Cout( "free v;"<< inwires[k]->value << endl);
		if (otval<0) { 
			if (inwires[k]->value==nval) ///break; // 1 good is enough
				return vUndef;
		   if (inwires[k]->value==1-otsval) { sval=vUndef; } // bad for other sens
		} else {
		 if (inwires[k]->value==1-otval) { nval=vUndef; sval=vUndef; } // bad for all others
		}	
	}
	else full=0;
	} // for
	

if (i<0) i=0; else i++;
// if (otval!=vUndef) for (k=0;k<i;k++) if (inwires[k]==vUndef) return -1;
if ((nval>=0)||(sval>=0)) {
  if (sensitive) { if (nval==vUndef) nval=otsval; }
  for (k=i;k<inputs;k++) if ((inwires[k]->value==vUndef)&&(inwires[k]->svalue==vUndef)) 
  { back=k;  break; }
  if ((back==vUndef)&&(!full)) { nval=vUndef; sval=vUndef; }
} // if
} // end not xory
return back;
}

// - drat se jmenem
void DDWire::makeLSet(int bits) {
	DBG_Cout("vytvarim! bitu:" << bits <<endl);
	PINs=new logic4Set[PinN](bits);
}

DDWire::DDWire(const char *nam) { 
	if (dbg_print) 
  		printf("new wire, name=%s %p\n",nam,this);
	DDClear();
	// s=makeArray<DDGate *>(2); 
	name=strdup(nam); 
};

// - drat od hradla ke hradlu
DDWire::DDWire(DDGate *in,DDGate *out,int whto,const char *nam) { 
	DDClear();
	togate=out; 
	//s=&out; 
	fromgate=in; 
	out->inwires[whto]=this; 
	in->outwire=this; 
	name=strdup(nam); 
}
// - drat s vetvenim od 1 do dvou hradel - uz nelze takhle
// DDWire(DDGate *in,DDGate *out1, DDGate *out2, const char *nam) { outputs=2; fromgate=in; togates=makeArray<DDGate *>(3); togates[0]=out1; togates[1]=out2; togates[2]=in; name=strdup(nam); };

DDWire::DDWire(int outs,const char *nam,int mainins) {  // n-fan
	DDClear();
	    			 if (dbg_print) 
				  printf("new wire, outs=%d name=%s %p\n",outs,nam,this);
				outputs=outs; 
				cpin=-1;
				name=strdup(nam);
				fromgate=NULL;
				togate=NULL;
				fromwire=NULL;
				FL=NULL;
 				makeLSet(mainins);
				// printf("new wir, outs=%d \n",outs); 
				if (outs>1) {
					towires=makeArray<DDWire *>(outs+1); 
					for(int i=0;i<outs+1;i++) {
						towires[i]=new DDWire(nam);
 						towires[i]->makeLSet(mainins);
						towires[i]->fromwire=this;
					}
	// printf("jmeno=%s \n",nam);
				}
				else towires=NULL;
};

//------------- ziskani retezce z typu ---------
const char *getGName(int gTyp) {
    switch(gTyp) {
	case tNOT: return "NOT";;
	case (tAND|tNOT): return "NAND";;
	case tAND: return "AND";;
	case (tOR|tNOT): return "NOR";;
	case tOR: return "OR";;
	case (tXOR|tNOT): return "XNOR";;
	case tXOR: return "XOR";;
	case tMUX: return "MUX";;
    }
    return "UND";
}

//------------- ziskani typu z retezce ------------

int getType(MStr eval_param) {
    if (eval_param=="NAND") return (tAND|tNOT);
    else if (eval_param=="AND") return (tAND);
    else if (eval_param=="NOR" || eval_param=="NOT" || eval_param=="INV") return (tOR|tNOT);
    else if (eval_param=="OR" || eval_param=="DFF" || eval_param == "BUFF") return (tOR);
    else if (eval_param=="XOR") return (tXOR);
    else if (eval_param=="XNOR") return (tXOR|tNOT);
    else if (eval_param=="MUX") return (tMUX);
    else return (tUND);
 }

//------------- tisk hradel obvodu od vstupu -------------
void printcircg(DDGate *DG,int uncheck);

void printwireg(DDWire *WG,int uncheck) // rep!
{
	 cout << WG->name <<"l:" << WG->level << "L:" <<WG->olevel << '[' << WG->fromgate << "](";
	// cout << WG->name <<':'<< WG->fromgate->name << '(';
	// for (int i=0;((i<WG->outputs)&&(WG->togates[i]!=NULL));i++) printcircg(WG->togates[i],uncheck);
	for (int i=0;((i<WG->outputs)&&(WG->togate!=NULL));i++) printcircg(WG->togate,uncheck);
	for (int i=0;((i<WG->outputs)&&(WG->towires!=NULL));i++) printwireg(WG->towires[i],uncheck);
	cout << ')';
}

//------------- 
void printcircg(DDGate *DG,int uncheck)
{
if(uncheck!=DG->un_checked) {
	DG->un_checked=uncheck;
	cout << DG->name << "_" << getGName(DG->gTyp) << "l:" << DG->level <<"L:" <<DG->olevel <<'[';; 
	for(int i=0; i < DG->inputs; i++) cout <<  DG->inwires[i] << ':';
	cout << "](";
	if (DG->outwire!=NULL) printwireg(DG->outwire,uncheck);
	cout << ')' ; 
 } // uncheck
}

//------------- tisk obvodu od vstupu -------------
void printcirc(DDGate *DG);

void printwire(DDWire *WG) // rep!
{
	cout << WG->name << '[' << WG->fromgate << "](";
	// cout << WG->name <<':'<< WG->fromgate->name << '(';
	// for (int i=0;((i<WG->outputs)&&(WG->togates[i]!=NULL));i++) printcirc(WG->togates[i]);
	for (int i=0;((i<WG->outputs)&&(WG->togate!=NULL));i++) printcirc(WG->togate);
	cout << ')';

}

//------------- 
void printcirc(DDGate *DG)
{
	cout << DG->name << "_" << getGName(DG->gTyp) << '[';; 
	for(int i=0; i < DG->inputs; i++) cout <<  DG->inwires[i] << ':';
	cout << "](";
	if (DG->outwire!=NULL) printwire(DG->outwire);
	cout << ')' ; 

}


//------------- tisk obvodu od vystupu ---------
void printback(DDGate *DG);
void printbackw(DDWire *WG)
{
	cout << WG->name << "=(" ; 
	if (WG->fromgate!=NULL) printback(WG->fromgate);
	cout << ')';
}

//-------------
void printback(DDGate *DG)
{
	cout << DG->name << "_" << getGName(DG->gTyp) << '(' ;; 
	for(int i=0; i < DG->inputs; printbackw(DG->inwires[i]), i++);
	cout << ")";
}


//------------- tisk hradel obvodu od vystupu ---------
void printbackg(DDGate *DG,int uncheck);
void printbackwg(DDWire *WG,int uncheck)
{
	cout << WG->name << "=(" ; 
	if (WG->fromgate!=NULL) printbackg(WG->fromgate,uncheck);
	 else if (WG->fromwire!=NULL) printbackwg(WG->fromwire,uncheck);
	 else cout << "null";
	cout << ')';
}

//-------------
void printbackg(DDGate *DG,int uncheck)
{
if(uncheck!=DG->un_checked) {
	DG->un_checked=uncheck;
	cout << DG->name << "_" << getGName(DG->gTyp) << '(' ;; 
	for(int i=0; i < DG->inputs; printbackwg(DG->inwires[i],uncheck), i++);
	cout << ")";
 } // uncheck
}

//------------- poruchovy simulator ---------
int simulate(DDGate *DG,int &check);
int simulatew(DDWire *WG,int &check)
{
	int val; 
	if (dbg_print) cout << WG->name << "=(" << mujendl;  
	if (WG->fromgate!=NULL) {
		val=simulate(WG->fromgate,check);
	} else val=WG->value;
	if (dbg_print) cout << ":" <<  val << mujendl;
	if (dbg_print) cout << ')' << mujendl;
	return val; 
}

//-------------
int simulate(DDGate *DG,int &check)
{
int val=DG->value;
if (check==DG->un_checked) { 
    if (dbg_print) cout << "=>" << val << ")";
    return val;
}
int sout=0;

 if (dbg_print) cout << DG->name << "_" << getGName(DG->gTyp) << '(' ;
 if (DG->gTyp&tAND)  {
	sout=1;
       for(int i=0; ((i < DG->inputs)&&(sout)); (sout=sout&simulatew(DG->inwires[i],check)), i++) 
	        if (dbg_print) cout <<"+a+" << sout << " ";
 }
 else 
	if (DG->gTyp&tOR) {
		sout=0;
       		for(int i=0; ((i < DG->inputs)&&(not sout)); (sout=sout|simulatew(DG->inwires[i],check)), i++) if (dbg_print) cout <<"+o+" << sout << " ";
	}

 // for(int i=0; i < DG->inputs; simulatew(DG->inwires[i],check), i++);

 DG->un_checked=check;

 // cout << "t" << DG->gTyp;
 if (DG->gTyp&tNOT) val=not sout;
 else val=sout;

 DG->value=val;

if (dbg_print) cout << ":" << val << ")";
return val;
}

//------------- dopredny poruchovy simulator ---------
int simulatef(DDGate *DG,int &check);
int simulatefw(DDWire *WG,int &check) // rep!
{
	int val,nval; 
	for(int i=1; i<WG->outputs; i++) {
		// val=WG->togates[i]->value;
		val=WG->togate->value;
		// if (val!=(nval=simulatef(WG->togates[i],check)))
		if (val!=(nval=simulatef(WG->togate,check)))
			return nval;
	}
	/*
	if (dbg_print) cout << WG->name << "=(" << mujendl;  
	if (WG->outputs!=0) {
		val=simulatef(WG->fromgate,check);
	} else val=WG->value;
	if (dbg_print) cout << ":" <<  val << mujendl;
	if (dbg_print) cout << ')' << mujendl;
	return val; 
	*/
}

//-------------
int simulatef(DDGate *DG,int &check)
{
int val=DG->value;
if (check==DG->un_checked) { 
    if (dbg_print) cout << ":" << val << ")";
    return val;
}
int sout=0;

 if (dbg_print) cout << DG->name << "_" << getGName(DG->gTyp) << '(' ;
 if (DG->gTyp&tAND)  {
	sout=1;
       for(int i=0; ((i < DG->inputs)&&(sout)); (sout=sout&simulatefw(DG->inwires[i],check)), i++) 
	        if (dbg_print) cout <<"+a+" << sout << " ";
 }
 else 
	if (DG->gTyp&tOR) {
		sout=0;
       		for(int i=0; ((i < DG->inputs)&&(not sout)); (sout=sout|simulatefw(DG->inwires[i],check)), i++) if (dbg_print) cout <<"+o+" << sout << " ";
	}


 DG->un_checked=check;
 
 if (DG->gTyp&tNOT) val=not sout;
 else val=sout;

 DG->value=val;

if (dbg_print) cout << ":" << val << ")";
return val;
}

//------------- funkce pro propojovani hradel a dratu --------
void connectGoutW(DDGate *G,DDWire *WG) {
 G->outwire=WG;
}
//-------------
void connectGinW(DDGate *G,DDWire **WG) {
 for(int i=0;i<G->inputs;i++) G->inwires[i]=WG[i];
}
//-------------
void connectWfromG(DDWire *WG,DDGate *G) {
 WG->fromgate=G;
}
//-------------
void connectWtoG(DDWire *WG,DDGate **G) { // rep!
 // for(int i=0;i<WG->outputs;i++) WG->togates[i]=G[i];
 for(int i=0;i<WG->outputs;i++) WG->togate=G[i];
}
void connectWtoGn(DDWire *WG,DDGate *G,int m,int n) { //rep!
 // WG->togates[m]=G;
 WG->togate=G;
 G->inwires[n]=WG;
}

// ------------ DDObj metody ------------
//
void DDObj::printCGI() {
// print circuit gates from inputs 
cout << "inputs (" << inputs << "):\n";
 for(int i=0;i<inputs;i++)
 {
 un_checked++;
 if (Inputs[i]!=NULL) printwireg(Inputs[i],un_checked);
 cout << endl;
 }
}
 
void DDObj::printCFI() {
// print circuit from inputs 
cout << "inputs (" << inputs << "):\n";
 for(int i=0;i<inputs;i++)
 {
 if (Inputs[i]!=NULL) printwire(Inputs[i]);
 cout << endl;
 }
}

void DDObj::printCGO() {
// print circuit gates from outputs 
cout << "outputs (" << outputs << "):\n";
 for(int i=0;i<outputs;i++)
 {
 un_checked++;
 if (Outputs[i]!=NULL) printbackwg(Outputs[i],un_checked);
 cout << endl;
 }
}

void DDObj::printCFO() {
// print circuit from outputs 
cout << "outputs (" << outputs << "):\n";
 for(int i=0;i<outputs;i++)
 {
 if (Outputs[i]!=NULL) printbackw(Outputs[i]);
 cout << endl << endl << endl;
 }
}

//------------- prepocteni urovni od vystupu ---------
int recalcg(DDGate *DG,int uncheck);
int recalcw(DDWire *WG,int uncheck)
{
int lev=0;
if (WG->un_checked!=uncheck) {
	WG->un_checked=uncheck;
	if (WG->fromgate!=NULL) lev=recalcg(WG->fromgate,uncheck);
	 else if (WG->fromwire!=NULL) lev=recalcw(WG->fromwire,uncheck);
	return (WG->level=lev)+1;
} else return WG->level+1;
}

//-------------
int recalcg(DDGate *DG,int uncheck)
{
int lev,mlev=-1;
if(uncheck!=DG->un_checked) {
	DG->un_checked=uncheck;
	for(int i=0; i < DG->inputs; i++) 
	{	lev=recalcw(DG->inwires[i],uncheck);
	      	if (mlev==-1) mlev=lev; 
		if (mlev>lev) mlev=lev;
	}
	DG->level=mlev;
	return mlev+1;
 } // uncheck
else return DG->level+1;
}

void DDObj::Recalc() { // recalculate levels in circuit
un_checked++;
 for(int i=0;i<outputs;i++)
 if (Outputs[i]!=NULL) recalcw(Outputs[i],un_checked);
DDFault *Fx=FaultList;
wires=0;
while (Fx!=NULL) { wires++; Fx=Fx->next; }
}

char *noblank(char *x) {
while ((x!=NULL)&&((x[0]==' ')||(x[0]=='\t'))) x++;
return x;
}

int DDFault::compareFS(char *sfault){
char *x=NULL;
DDWire *w2;
int back=0;
if ((fw!=NULL)&&(sfault!=NULL)) {
	DBG2_Cout("p1:" << sfault << endl,2);
	if ((x=strstr(sfault,fw->name))!=NULL) {
		x+=strlen(fw->name);
		DBG_Cout("p2:" << x << endl);
		// while (x[0]==' ') x++;
		x=noblank(x);
		DBG_Cout("p2b:" << x << endl);
		if ((x[0]=='-')&&(x[1]=='>')) {
			x+=2;
			DBG_Cout("p3:" << x << endl);
			if (fw->togate!=NULL) {
				w2=fw->togate->outwire;
				if ((x=strstr(x,w2->name))!=NULL) {
					x+=strlen(w2->name);
					DBG_Cout("p4:" << x << endl);
					// while (x[0]==' ') x++;
					back=1;
				}
			} else back=0;
		}
		else if (fw->fromwire==NULL)  back=1;
	}
} // null
if (back) { 
	back=0;
	x=noblank(x); 
	DBG_Cout("p5b:" << x << endl);
	if (x[0]=='/') {
		x++;
		DBG_Cout("p5b:" << x  << ", sa:" <<stuckAt << endl);
		if (((x[0]=='1')&&(stuckAt==1))||((x[0]=='0')&&(stuckAt==0)))
			back=1;
	}
}
return back;
}

void DDObj::readFaults(char *fname) {
DDFault *pom;
FILE *f;
char cin;
int found;
int read,i=0;
char sfault[256]; // fault name
f=fopen(fname,"r");
int newline=0;
	DBG_Cout( "reading faults file " << fname << endl);
	while (pom!=NULL) {
		pom->active=0;
		DBG_Cout( "fault:" << pom->fw << endl);
		pom=pom->next;
	}
sfault[0]='\0';
do {
	read=fread(&cin,1,1,f);
	DBG2_Cout( "read:" << cin << endl,2);
	switch(cin) {
		case '\xD': newline=1;;
		case '\xA': newline=1; break;;
		default: if(newline) break; else {
				 sfault[i++]=cin;
				 sfault[i]='\0';
			 };
	}
	if ((newline)&&(sfault[0]!='\0')) {  // search for fault in FL
		sfault[i++]='\0';
		DBG_Cout( sfault << endl);
		pom=FaultList;
		found=0;
		while (pom!=NULL) {
			if (pom->compareFS(sfault)) { found=1; break; }
			pom=pom->next;
		}
		if (!found) cerr << "Porucha: \"" << sfault << "\" nenalezena!" << endl;
		else pom->active=true;
		i=0;
		newline=0; 
		sfault[0]='\0';
	}
} while(read>0);
fclose(f);
}

int DDObj::setVector(int *vvektor) {
// set and print the input vector to circuit 
DBG_Cout( "vektor:\n");
 for(int i=0;i<inputs;i++)
 {
	 if (dbg_print) cout << vvektor[i] << " ";
//	 cout << Inputs[i] << endl;
	 if (mask!=NULL) { if ((vvektor[i]!=mask[i])&&(mask[i]!=vUndef)&&(vvektor[i]!=vUndef)) return 0; } // check for mask mismatch
	 Inputs[i]->value=vvektor[i];
 }
DBG_Cout(endl);
return 1;
}

int recalcX(DDGate *DG,int index, int stuckAt);
int simulateX(DDGate *DG,int &check);
int simulatewX(DDWire *WG,int &check);

int *DDObj::Simulate() {
// simulation 
int *ovektor=makeArray<int>(outputs);
if (dbg_print) cout << "simulate outputs (" << outputs << "):\n";
int val;
un_checked++;
un_checked=rand();
for(int i=0;i<outputs;i++)
 {
  if (Outputs[i]!=NULL) val=simulatewX(Outputs[i],un_checked);
  if (dbg_print) cout << "=" << val << endl;
  ovektor[i]=val;
 }
return ovektor;
}

// recalculate one value

int recalc(DDGate *DG,int index, int stuckAt) {
int val;
int i;
val=DG->value;
int check;
check=DG->un_checked;

 if (dbg_print) cout << DG->name << "_" << getGName(DG->gTyp) << '(' ;
 if (DG->gTyp&tAND)  {
	val=1;
       for(i=0; ((i < index)&&(val)); (val=val&simulatew(DG->inwires[i],check)), i++) 
	        if (dbg_print) cout <<"+a+" << val << " ";
      if (val&&stuckAt) // break the condition ((not val)||(not stuckAt))
       for(++i; ((i < DG->inputs)&&(val)); (val=val&simulatew(DG->inwires[i],check)), i++) 
		{ if (dbg_print) cout <<"+a+" << val << " "; }
      else val=val&&stuckAt;
 }
 else 
	if (DG->gTyp&tOR) {
		val=0;
       		for(i=0; ((i < index)&&(not val)); (val=val|simulatew(DG->inwires[i],check)), i++) if (dbg_print) cout <<"+o+" << val << " ";
       if ((not val)&&(not stuckAt)) // break the condition
       	for(++i; ((i < DG->inputs)&&(not val)); (val=val|simulatew(DG->inwires[i],check)), i++) 
		{ if (dbg_print) cout <<"+o+" << val << " "; }
       else val=val||stuckAt;  
	}

if (DG->gTyp&tNOT) val=not val;

if (dbg_print) cout << ":" << val << ")" << endl;
return val;
}

// injection

void DDObj::Inject(int *correct) {
if (dbg_print) cout << "fault injection(" << outputs << "):\n";
DDGate *fg;
DDFault *fl;
int *testout;
fl=FaultList;
cout << "f1:" <<fl->fg << endl;
if (fl->fg==NULL) fl=fl->next;
int val;
cout << "f2:" <<fl->fg << endl;
while ((fl!=NULL)&&(fl->fg!=NULL)) {
  fg=fl->fg; 
  fg->un_checked++; // must be equal to global check++
  val=fg->value;
  if (dbg_print) cout << "trying: " << fl->fg->inwires[fl->index]->name << "/" << fl->stuckAt << endl;
  fg->value=recalc(fg,fl->index,fl->stuckAt); // injection
  // with new value simulate again
  testout=Simulate();
  for(int i=0,ch=0;i<outputs;i++) 
	  if (testout[i]!=correct[i]) { 
	   if (ch==0) {
	     cout << endl;
	     cout << fg->inwires[fl->index]->name << "/" << fl->stuckAt << ": ";
	     ch=1;
	   }
		cout << "o" << i << "->" << testout[i] << "; ";
  	} // if-for
  fg->value=val;
  fl=fl->next;
 } // while
 cout << endl << endl;
}

void printVect(int *V,int size) {
int x;
if (V!=NULL)
	for(int i=0;i<size;i++) 
		if ((x=V[i])>=0) cout << x;
		else cout << "X";
}

int DDObj::InjectX(int *correct) {
if (dbg_print) cout << "fault injection(" << outputs << "):\n";
DDWire *fw;
DDFault *fl;
int ch=0;
int *testout;
fl=FaultList;
int val;
while (fl!=NULL) {
if (fl->fw!=NULL) {
  fw=fl->fw;
  val=fw->value;
  fw->un_checked++; // must be equal to global check++
  fw->value=fl->stuckAt;
  // if (dbg_print) cout << "trying: " << fl->fg->inwires[fl->index]->name << "/" << fl->stuckAt << endl;
  // with new value simulate again
  printVect(correct,outputs);
  cout << endl;
  testout=Simulate();
  printVect(testout,outputs);
  cout << endl;
  for(int i=0;i<outputs;i++) 
	  if (testout[i]!=correct[i]) { 
	   if (ch==0) {
	     cout << endl;
	     cout << fw->name << "/" << fl->stuckAt << ": ";
	     ch=1;
	   }
		cout << "o" << i << "->" << testout[i] << "; ";
  	} // if-for
  if (ch) {
	  // printVector(testout,outputs);
	  fl->active=0;
  }
  fw->value=val;
}
  fl=fl->next;
  ch=0;
 } // while
 cout << endl << endl;
 return ch;
}

// essential input values
int touch_back(DDWire *DW, int backValue) {
if (DW->fromgate->state==pUndef) {
	DW->fromgate->state=pBack; // 
	DW->fromgate->value=backValue;
	DW->value=backValue;
}
else if (DW->fromgate->value!=backValue) return 1; // 
return 0;
}

// fault propagation
int propagate(DDGate *DG,int input, int forceValue, DDGate **NotSure,DDGate **FanOuts,int &check) { // rep!
int i,back,forw;
int fOut=(forceValue=forceValue&&!(DG->gTyp&tNOT));
int backVal=-1;
int possible=1;

if (check==DG->un_checked) return 1;
DG->un_checked=check;
// neni nutne vedet stav? teoreticky je poprve vzdy jako undef
// to pri fan-outech bude vadit, musi se vlozit do seznamu
// moznych pruchodu
if ((DG->state==pOpen)&&(DG->value!=forceValue)) { 
	return 1;
}
DG->state=pOpen;

switch ((DG->gTyp)&(~tNOT)) { // set type dependents 
	case tAND: backVal=1;
		  break;; 
	case tOR: backVal=0;
		  break;; 
	case tXOR: backVal=!forceValue;
		   fOut=backVal;
		   possible=2;
		  break;; 
}
	
while (possible) {
for(i=0;i<DG->inputs;i++) // backward needed values
	if (i!=input) if (back=touch_back(DG->inwires[i],backVal)!=0) break; 

if (back!=0) { } // conflict setting gate inputs

for(i=0;i<DG->outwire->outputs;i++)  // forward propagation
	// if (forw=propagate(DG->outwire->togates[i],i,fOut,NotSure,FanOuts,check)!=0) break;
	if (forw=propagate(DG->outwire->togate,i,fOut,NotSure,FanOuts,check)!=0) break;
possible--;

backVal=~backVal;// pouze pro xor, musi se zobecnit
fOut=~fOut;
} // while

return 0;
}

// consistency - setting up inputs
int set_up(DDGate *DG, int forceValue, DDGate **NotSure,int &check) {

}

//------------- poruchovy simulator s hodn. Don't Care ---------
int simulateX(DDGate *DG,int &check);
int simulatewX(DDWire *WG,int &check)
{
int val; 
if (check==WG->un_checked) val=WG->value;
else {
	WG->un_checked=check;
	DBG_Cout(WG->name << "=(" << mujendl);  
	if (WG->fromgate!=NULL) {
		val=simulateX(WG->fromgate,check);
	} else if(WG->fromwire!=NULL)  val=simulatewX(WG->fromwire,check);
	else val=WG->value;
	DBG_Cout (":" <<  val << mujendl);
	DBG_Cout (')' << mujendl);
}
	if (val!=vUndef) WG->state=pOpen;
	return val; 
}

//-------------
int simulateX(DDGate *DG,int &check)
{
int val=DG->value;
if (check==DG->un_checked) { 
    DBG_Cout ( "=>" << val << ")");
    return val;
}
int sout=0;
int sx;

 DBG_Cout (DG->name << "_" << getGName(DG->gTyp) << '(') ;
 if (DG->gTyp&tAND)  {
	sout=1;
	for(int i=0; ((i < DG->inputs)&&(sout!=0)); i++)
	{
		sx=simulatewX(DG->inwires[i],check);
		if ((sx!=vUndef)&&(sout!=vUndef))
			sout=sout&sx;
		else if (sx!=1) sout=sx;  
	        DBG_Cout ("+a+" << sout << " ");
	}
 }
 else 
	if (DG->gTyp&tOR) {
		sout=0;
       		for(int i=0; ((i < DG->inputs)&&(sout!=1)); i++) {
			sx=simulatewX(DG->inwires[i],check);
			if ((sx!=vUndef)&&(sout!=vUndef))
				sout=sout|sx;
			else if (sx!=0) sout=sx;
			DBG_Cout ("+o+" << sout << " ");
		}
	}
 else if(DG->gTyp&tXOR) { 
		int sy;
		sout=vUndef;
		if ((sx=simulatewX(DG->inwires[0],check))!=vUndef) 
			if ((sy==simulatewX(DG->inwires[1],check))!=vUndef)
				sout=sy xor sx;
			DBG_Cout ("+x+" << sout << " ");
		/*
	 if ((sx=simulatewX(DG->inwires[1-index],check))!=vUndef) val=val xor sx;
	 else val=sx;
	 */
 }

DG->un_checked=check;
if(sout!=vUndef) {
 if (DG->gTyp&tNOT) val=not sout;
 else val=sout;
} else val=sout;

 DG->value=val;
 if (val!=vUndef) DG->state=pOpen;

DBG_Cout (":" << val << ")");
return val;
}


int recalcX(DDGate *DG,int index, int stuckAt) {
int val;
int i;
val=DG->value;
int check;
int sx,sy;
check=DG->un_checked;

 if (dbg_print) cout << DG->name << "_" << getGName(DG->gTyp) << '(' ;
 if (DG->gTyp&tAND)  {
	val=1;
       for(i=0; ((i < index)&&(val)&&(val!=vUndef)); i++) {
		sx=simulatewX(DG->inwires[i],check);
		if ((sx!=vUndef)&&(val!=vUndef)) val=val&sx;
		else if (sx!=1) val=sx;
	        DBG_Cout ("+a+" << val << " ");
       }
      if (val&&stuckAt&&(val!=vUndef)) // break the condition ((not val)||(not stuckAt))
       for(++i; ((i < DG->inputs)&&(val)); i++) {
		sx=simulatewX(DG->inwires[i],check);
		if ((sx!=vUndef)&&(val!=vUndef)) val=val&sx;
		else if (sx!=1) val=sx;
	        DBG_Cout ("+a+" << val << " ");
       }
      else if (val!=vUndef) val=val&&stuckAt; 
 }
 else 
	if (DG->gTyp&tOR) {
		val=0;
       		for(i=0; ((i < index)&&(not val)); i++) { 
			sx=simulatewX(DG->inwires[i],check);
			if ((sx!=vUndef)&&(val!=vUndef)) val=val|sx;
			else if (sx!=0) val=sx; 
		       	DBG_Cout ("+o+" << val << " ");
		}	
       if ((val!=vUndef)&&(not val)&&(not stuckAt)) // break the condition
       		for(++i; ((i < index)&&(not val)); i++) { 
			sx=simulatewX(DG->inwires[i],check);
			if ((sx!=vUndef)&&(val!=vUndef)) val=val|sx;
			else if (sx!=0) val=sx; 
		       	DBG_Cout ("+o+" << val << " ");
		}	
       else if (val!=vUndef) val=val||stuckAt;  
	}
 else if(DG->gTyp&tXOR) { 
	 /*
		int sy;
		sout=vUndef;
		if ((sx==simulatewX(DG->inwires[0],check))!=vUndef) 
			if ((sy==simulatewX(DG->inwires[1],check))!=vUndef)
				sout=sy xor sx;
			DBG_Cout ("+x+" << sout << " ");
		val=sout;
		*/
	 if ((sx=simulatewX(DG->inwires[1-index],check))!=vUndef) val=val xor sx;
	 else val=sx;
 }

if(val!=vUndef) {
 if (DG->gTyp&tNOT) val=not val;
}

DBG_Cout (":" << val << ")" << endl);
return val;
}

// injection

