/**********************************
* Tables for evaluation 
*
**********************************/

#ifndef hTables
#define hTables

#define MAXGATES 10
#define DSize 5
#define BSize 4

// wire values

// ...will not use these
#define ZERO 0
#define ONE 1

#define X 2
#define Z 3
#define D 4
#define Dbar 5
#define E 6
#define Mi 7
#define La 8
#define Un  9

typedef int signal;

signal DPrunik[DSize][DSize]={
	//	0	1	X	D	Dbar
	{	0,	E,	0,	Un,	Un	}, // 0
	{	E,	1,	1,	Un,	Un	}, // 1
	{	0,	1,	X,	D,	Dbar	}, // X
	{	Un,	Un,	D,	Mi,	La	}, // D
	{	Un,	Un,	Dbar,	La,	Mi	}  // Dbar
};
	  
signal BasicsD[BSize][2][3]={
	//	1st	2nd	Out
	{{	D,	1,	D	},	// and
	{	1,	D,	D	}},
	{{	D,	0,	D	},	// or
	{	0,	D,	D	}},
	{{	D,	1,	Dbar	},	// nand
	{	1,	D,	Dbar	}},
	{{	D,	0,	Dbar	},	// nor
	{	0,	D,	Dbar	}}	// nor
};

signal Basics[BSize][2][3]={
	//	1st	2nd	Out
	{{	0,	X,	0	},	// and
	{	1,	1,	1	}},
	{{	1,	X,	1	},	// or
	{	0,	0,	0	}},
	{{	0,	X,	1	},	// nand
	{	1,	1,	0	}},
	{{	1,	X,	0	},	// nor
	{	0,	0,	1	}}
};

signal Fixed[4][3]={
	{	0,	0,	0	},
	{	0,	1,	1	},
	{	1,	0,	1	},
	{	1,	1,	0	}
};

signal FixedD[4][3]={
	{	0,	D,	D	},
	{	D,	0,	D	},
	{	D,	1,	Dbar	},
	{	1,	D,	Dbar	}
};

#endif 
