#include "structure.h"
#include "utility.h"
#include <ctype.h>

/*
int
printf VPARAMS ((const char *format, ...))
{
int result;
VA_OPEN (ap, format);
VA_FIXEDARG (ap, const char *, format);
result = vfprintf (stdout, format, ap);
VA_CLOSE (ap);
return result;
}
*/
int vectors;
int allvect;
int loops;
int kit=-10000000;
int **VECT;
extern int max_vectors;

DDFault *FaultList;
DDObj *mujobv;
int backtrack=0;

// add new fault into FL
DDFault *AddFault(DDWire *newWire) { 
	DDFault **tfl=&(newWire->FL); // ziskam ukazatel na FL
	if (*tfl==NULL) { // vytvorim novou poruchu
		*tfl=new DDFault(FaultList,0,newWire);  
	}
	else  *tfl=new DDFault((*tfl),0,newWire);
*tfl=(*tfl)->next;
return *tfl;
}

// add fault - old gate style
DDFault *AddFault(DDWire *newWire,int i, int k) { 
	// DDFault **tfl=&(newWire->togates[i]->FL); // ziskam ukazatel na FL
	DDFault **tfl=&(newWire->FL); // ziskam ukazatel na FL
	if (*tfl==NULL) { // vytvorim novou poruchu
		*tfl=new DDFault(FaultList,0,newWire->togate,k);  
	}
	else  *tfl=new DDFault((*tfl),0,newWire->togate,k);
*tfl=(*tfl)->next;
return *tfl;
}

//---------------------------------------------------------------------------
void save(Object *o,const char *filename)
{
   try
   {
      o->saveBench(filename);
      // o->saveBench(edtSaveBench->Text.c_str());
   }
   catch(...)
   {
      DBG_Cout( "Chybn naten zazen");
      // Application->MessageBox("Chybn naten zazen","Chyba",MB_OK);
      return;
   }
}
//---------------------------------------------------------------------------

Object* open(const char* inputfile)
{
   Object *o;
   Bench bench;
   DBG_Cout( "Reading object from " << inputfile << "...");
   o=bench.get_object(inputfile);
   DBG_Cout( "done\n");

   if (dbg_basic) cerr << "Object name: " << o->name << endl; 
   if (dbg_basic) cerr << "Number of gates: " << bench.CurrentGateNumber << endl; 

    //  for(map<MStr,Wire *>::iterator ww=i->second->wires.begin();ww!=i->second->wires.end();ww++)
      //  cout << "drat: " << ww->second->name << ":" << ww->first << endl;
return o;
}



//----------pruchod strukturou-----------
// DDWire *getWire(Wire *ww,Port *pp);
DDWire *getWire(Wire *ww,Port *pp,int lev,int &olev);

//----------pruchod strukturou-----------
DDGate *getGate(Object *ob,int lev,int &olev) { 
DDGate *newGate=new DDGate(getType(ob->eval_param),ob->InputPorts.size(),1,ob->name.c_str());
   ob->myGate=newGate;  // where in the structure is new obj
   ob->on_zjisteno=true; // now it is in the structure
   int i=0;
   int flev;
   DBG_Cout( '{');
   list<Port *>::iterator op=ob->OutputPorts.begin(); 
   for(list<Port *>::iterator j=op;(j!=ob->OutputPorts.end());j++,i++) { // pres vsechny porty
	DBG_Cout("hradlo" << ob->name << "(" << ob << ") port " << (*j)->name << "(" << (*j) << ") " <<  "vstupu " << newGate->inputs << endl);
	// DBG_Print("hradlo %s (%p) port %s (%p), vstupu %d\n",ob->name.c_str(),ob,(*j)->name.c_str(),(*j),newGate->inputs));
	newGate->outwire=getWire((*j)->wire_up,(*j),lev+2,flev);
	newGate->inwires[newGate->inputs]=newGate->outwire; // simplyfing throughput
	newGate->outwire->fromgate=newGate; // self backward set up
   }
   DBG_Cout( '}');
   newGate->level=lev+1;
   newGate->olevel=flev;
   olev=flev+1;   
return newGate;
}

//----------pruchod strukturou-----------
DDWire *getWire(Wire *ww,Port *pp,int lev,int &olev) {  // create new wire from structure
 DDWire *newWire=new DDWire(ww->prefs.size()-1,ww->name.c_str(),mujobv->inputs);
 DDGate *nGate;
 	// new wire and fans if >1
 int i=0;
 int flev=0,mflev=-1;
 if (ww->prefs.size()>1) // at least from-to
 {
   if (ww->prefs.size()>2) lev++; // fan in +1 level
   for(list<Port *>::iterator j=ww->prefs.begin();(j!=ww->prefs.end());j++) { // prefs.begin-end - vsecky porty na dratu
	Object *h=(*j)->object; // objekt na kterem je port
	if ((h->typobjektu!=tOBJ)&&(pp->object)!=(h)) { // neprochazim hlavni objekt a odkud vystupuje drat
		DBG_Cout("vodic " << ww->name << "(" << ww << ") -> hradlo" << h->name << "(" << h << ":" <<  h->on_zjisteno << "), i=" << i << endl);
			//	",ww->name.c_str(),ww,h->name.c_str(),h,h->on_zjisteno,i));

		if (h->on_zjisteno) {
			nGate=h->myGate; // get gate from obj
			flev=nGate->olevel+1; // get it's output level
			if (nGate->level>lev+1) nGate->level=lev+2; // what about the others?
		}
		 else nGate=getGate(h,lev+1,flev); // or make new gate 


		if (newWire->towires==NULL) { // straight to wire
			newWire->togate=nGate; 
		 for(int k=0;(k<nGate->inputs);k++) // search for free input pointer
			if(nGate->inwires[k]==NULL)  // could be optimized by counter
			{
				nGate->inwires[k]=newWire; // look back also
				// AddFault(newWire,i,k); // pridam poruchy na fan vstupech 
   		 		 AddFault(newWire); // add no-fan faults
 	  			break;
			}
		 	if (mflev==-1) mflev=flev; 
		 }
		else {
		 newWire->towires[i]->togate=nGate; // we go to gate through fan
		 AddFault(newWire->towires[i]); // add faults - fan-outs
		 if (i==0) {
			 	AddFault(newWire); // add faults - fan-in
				lev--; // correcting action to fan-in
				// cout <<newWire->name << flev << endl;
		 }
		 if (mflev==-1) mflev=flev+1; 
		 if (mflev>flev+1) mflev=flev+1;
		 newWire->towires[i]->level=lev+2;
		 newWire->towires[i]->olevel=flev;
		 // cout << " flev : " << flev <<endl;
		 for(int k=0;(k<nGate->inputs);k++) // searach for free input pointer  
			if(newWire->towires[i]->togate->inwires[k]==NULL)  //  
			{
				nGate->inwires[k]=newWire->towires[i]; // look back 
				// if (newWire->outputs>1)  ??
				// AddFault(newWire->towires[i],i,k); //  add faults
 	  			break;
			}
		}
	 	i++;
	} // end if output ports
   } // end for ports 
   if ((newWire->togate==NULL)&&(newWire->towires==NULL)) AddFault(newWire); // add faults - fan-outs
 } // end if >1
 else if (ww->prefs.size()<2) { // no output wire
	cerr << "Vodic: " << ww->name.c_str() << endl << "Chyba ve strukture!" <<  endl; 
	exit(1);
 }
   if (mflev==-1) mflev=0;
   newWire->level=lev+1;
   newWire->olevel=mflev;
   olev=mflev+1;
   return newWire;
}

//----------pruchod strukturou-----------
DDWire *getWires(Port *pp) {
return new DDWire(pp->name.c_str());
}

//----------transformace na moji strukturu------------
DDObj *transform(char *fname) {
Object *o;

// opening file
o=open(fname);

int inputs,outputs;
o->get_ports(inputs,outputs);
if (dbg_basic) cerr << "Input ports: " << inputs << endl;
if (dbg_basic) cerr << "Output ports: " << outputs << endl;

DDWire **InputWires=makeArray<DDWire *>(inputs);
// *InputWires->inputs=inputs;
DDWire **OutputWires=makeArray<DDWire *>(outputs);
// *OutputWires->outputs=outputs;

FaultList=new DDFault();

mujobv=new DDObj(FaultList,InputWires,OutputWires,inputs,outputs);

char *xname;
long int i=0,outs=0;
int lev=0,flev=0; // level of item
// cout << inputs << endl;
   o->typobjektu=tOBJ;
   for(list<Port *>::iterator j=o->InputPorts.begin();(j!=o->InputPorts.end());j++,i++) {
	// reading structure 
	  InputWires[i]=getWire((*j)->wire_down,(*j),lev,flev);  // get wires from input
	  InputWires[i]->cpin=i;
	  if ((InputWires[i]->towires==NULL)&&(InputWires[i]->togate==NULL))
		OutputWires[outs++]=InputWires[i];
	  DBG_Cout( "fan outs:"<<(*j)->wire_down->prefs.size() << endl);
   }
   i=outs;
   // outputs
   for(list<Port *>::iterator j=o->OutputPorts.begin();(j!=o->OutputPorts.end());j++,i++) { // assign output ports from ready structure
	Wire *wd=(*j)->wire_down;
	for(list<Port *>::iterator l=wd->prefs.begin();(l!=wd->prefs.end());l++)
	{	
	  if((*l)->object!=(*j)->object) {
		if(*((*l)->object->OutputPorts.begin())==(*l)) {
	    		DBG_Cout( "port name:" <<  (*l)->name << endl);
		 	DBG_Cout( "wire up:" << (*l)->wire_up << " i: " << i << endl);

			if ((*l)->object->myGate == NULL) { 
				cerr << "pri zpracovani " << (*j)->name << endl ;
				cerr << "chyba ve strukture!" <<  endl; 
			exit(1); 
			}
	     		OutputWires[i]=((*l)->object->myGate->outwire);
	  	}
	 }
	}	
   }
mujobv->Recalc();
return mujobv; 
// return final object with the circuit
}

//---------- tisk obvodu z puvodni struktury ------------
void printCircuit(Object *o) 
{

   for(map<MStr,Wire*>::iterator i=o->wires.begin();(printf("\nWIRE:%p\n",i->second))&&(i!=o->wires.end());i++)
   {
     Wire *os=i->second;
     DBG_Cout( "wire name: " << i->second->name << endl); 
     
     for(list<Port *>::iterator j=os->prefs.begin();(printf("PRefs:%p",*j))&&(j!=os->prefs.end());j++) {
          DBG_Cout( "= port: " << (*j)->name << endl);
        //  cout << "address: " ; printf("%p\n",(*j)->wire_up); 
    }
   }
  DBG_Cout( endl);

   for(list<Port *>::iterator j=o->InputPorts.begin();(printf("INs:%p\n",*j))&&(j!=o->InputPorts.end());j++) {
          DBG_Cout( "port name: " << (*j)->name << endl);
          // cout << "in port up: " << (*j)->wire_up->name << endl; 
          DBG_Cout( "in port up: " << (*j)->wire_up << endl); 
	   // DBG_Cout(("%p\n",(*j)->wire_up)); 
          DBG_Cout( "in port down: " << (*j)->wire_down << endl); }
	  //  DBG_Print(("%p\n",(*j)->wire_down)); }

   for(list<Port *>::iterator j=o->OutputPorts.begin();(printf("OUTs:%p\n",*j))&& (j!=o->OutputPorts.end());j++) {
		// printf("addr-%x\n",*j);
          DBG_Cout( "port name: " << (*j)->name << endl);
          // cout << "out port up: " << (*j)->wire_up->name << endl; 
          DBG_Cout( "out port up: " << (*j)->wire_up << endl); 
	   // DBG_Print(("%p\n",(*j)->wire_up)); 
          DBG_Cout( "out port down: " << (*j)-> wire_up << endl); }
	   // DBG_Print("%p\n",(*j)->wire_down); }


   for(map<MStr,Object *>::iterator i=o->objects.begin();(printf("\nobjs:%p\n",i->second))&&(i!=o->objects.end());i++)
   {
    	Object *os=i->second;
       DBG_Cout("object name: " << os->name << endl);
         DBG_Cout( "known: " << os->on_zjisteno << endl);
         DBG_Cout( "inputs: " << os->InputPorts.size() << endl);
        for(list<Port *>::iterator j=os->InputPorts.begin();(printf("ins:%p\n",*j))&&(j!=os->InputPorts.end());j++) {

          DBG_Cout( "in ports: " << (*j)->wire_up->prefs.size()<< endl);
          DBG_Cout( "in port: " << (*j)->name << endl);
          DBG_Cout( "in port up: " << (*j)->wire_up->name << endl); 
          DBG_Cout( "in port down: " ); 
	    DBG_Cout((*j)->wire_down << endl); }
        for(list<Port *>::iterator j=os->OutputPorts.begin();(printf("outs: %p\n",*j))&& (j!=os->OutputPorts.end());j++) {
          DBG_Cout( "out port: " << (*j)->name << endl);
          DBG_Cout( "out port up: " << (*j)->wire_up->name << endl); 
          DBG_Cout( "out port down: " ); 
	   DBG_Cout((*j)->wire_down << endl); 
	}
        for(map<MStr ,Wire *>::iterator j=os->wires.begin(); (printf("wires: %p\n",j->second))&& (j!=os->wires.end());j++) {
          DBG_Cout( "wire: " << j->second->name << endl);
          DBG_Cout( "addr: "); 
	   DBG_Cout(j->second << endl); 
	}
   } 
}

//---------------------------------------------------------------------------

void close(Object *o)
{
   delete o;
}


//-------------------obsolete structure operations--------------------------
void sens(Wire *w) {
     for(list<Port *>::iterator j=w->prefs.begin();(j!=w->prefs.end());j++) {
          DBG_Cout( "port: " << (*j)->name);
	  if ((*j)->wire_up!=NULL) DBG_Cout( ", up: " << ((*j)->wire_up));
	  if ((*j)->wire_down!=NULL) DBG_Cout( ", down: " << ((*j)->wire_down));
	  if ((*j)->object!=NULL) DBG_Cout( ", object: " << ((*j)->object->name) << " type: " << (*j)->object->eval_param);
	 DBG_Cout( endl);
    }
}

void printPort(list<Port *>::iterator j) {
          DBG_Cout( "port : " << (*j)->name);
	  if ((*j)->wire_up!=NULL) DBG_Cout( ", wire: " << ((*j)->wire_up));
	  if ((*j)->wire_down!=NULL) DBG_Cout( ", down: " << ((*j)->wire_down));
	  if ((*j)->object!=NULL) DBG_Cout( ", object: " << ((*j)->object->name) << " type: " << (*j)->object->eval_param);
	 DBG_Cout( endl);
}

void sensI(Wire *w) {
     for(list<Port *>::iterator j=w->prefs.begin();(j!=w->prefs.end());j++) 
      if ((*j)->wire_down==NULL)  // pouze vstupni me zajimaji
      {
	      if ((*j)->name!="O") printPort(j);
      }
}

 // ----------- vytvoreni a pruchod seznamu poruch ---------
void faultList(Object *o)
{
   for(map<MStr,Wire*>::iterator i=o->wires.begin();(printf("WIRE:%p  ",i->second))&&(i!=o->wires.end());i++)
   {
     Wire *os=i->second;
     DBG_Cout( "porucha : " << os->name << "_sa0/_sa1" << endl); 
   }
}
// ---------- vytvoreni a pruchod seznamu poruch ---------
void faultListI(Object *o) 
{
   for(map<MStr,Wire*>::iterator i=o->wires.begin();(i!=o->wires.end());i++)
   {
     Wire *os=i->second;
     sensI(os); 
   }
   for(map<MStr,Wire*>::iterator i=o->wires.begin();(i!=o->wires.end());i++)
   {
   }
}

// --- testing circuit - manual ----
void testCirc() { //rep! obsolete

// cout << rand() << endl;  pouziti
DDWire *bb,*b2, *b1;

bb=new DDWire(2,"bb",2);
b1=new DDWire("b1");

b2=new DDWire(new DDGate(tAND,3,0,"and1"),new DDGate(tOR,3,1,"or1"),0,"b2");
/*
bb->togates[0]=new DDGate(tAND,2,0,"and2");
bb->togates[1]=b2->fromgate;

 connectGoutW(bb->togates[0],b1);
 connectWtoGn(b1,(b2->togates[0]),0,1);
 printwire(bb);
 cout << endl;
// bb->togates=&(new DDGate(tAND,3,0,""));
//
*/
}

// -------------------- end obsolete -------------------

int isncar(int c) {
	return (isblank(c)||iscntrl(c)||(not isgraph(c)));
}

#define linnb 10
// --------- read vector file ---------
int **readVectors(char *fname) {
FILE *f;
char cin;
char sin[linnb];
int *vlin,**rV=NULL;
int read,k,n,vn=0,rval=0;
   DBG_Cout( "reading test vectors file " << fname << endl);
  f=fopen(fname,"r");
  DBG_Cout( "file: " << f << endl);
// rV=(int **)malloc(sizeof(int *));
 do {
  read=fread(&cin,1,1,f);
  if (isncar(cin)) while ((read=fread(&cin,1,1,f)>0)&&(isncar(cin)));
  if (read>0) 
	  if (cin=='*') while((read=fread(&cin,1,1,f)>0)&&(cin!='\xa'));  // comment
	  else {
		  DBG_Cout( " no comment :" << cin << endl);
	   k=0;
	   vn++;
		  DBG_Cout( " alloc rV " << endl);
	   rV=(int **)realloc(rV,(vn+1)*sizeof(int *));
		  DBG_Cout( " rV=" << rV << endl);

	   DBG_Cout( " read name" << endl);
	   if (cin!=':')
	   do { if (k<linnb) sin[k]=cin; } // read name
	     while ((read=fread(&cin,1,1,f)>0)&&(cin!=':'));
	    DBG_Cout( " read : " << endl);
	   if (read<1) break;
	     DBG_Cout( " read vector " << endl);
           while ((read=fread(&cin,1,1,f)>0)&&(isncar(cin))); // read vector 
	   if (read<1) break;
	   k=0;
	   n=1;
	    DBG_Cout( " valloc " << endl);
	   vlin=(int *)malloc(linnb*sizeof(int));
	     DBG_Cout( " valloc " << vn << ":" << rV << endl);
	   rV[vn-1]=vlin;
	   rV[vn]=NULL;
	    DBG_Cout( " valloc " << endl);
	    DBG_Cout( "v" << n << ":" << cin);
	   rval=3;
	   if (isdigit(cin)) rval=cin-'0';
	   else if ((cin=='x')||(cin=='X')) rval=-1;
	   if (rval<3) // good input
           do { 
	     if (k<linnb*n) vlin[k]=rval; 
	     else { 
		      n++; 
		      vlin=(int *)realloc(vlin,linnb*sizeof(int)*n); 
                      vlin[k]=rval;
	              rV[vn-1]=vlin;
		      rV[vn]=NULL;
	     }
	     DBG_Cout( cin);
	     k++;
	     rval=3;
	     read=fread(&cin,1,1,f);
	     if (isdigit(cin)) rval=cin-'0';
	     else if ((cin=='x')||(cin=='X')) rval=-1;
	   } while (read&&(rval<3)); // do
	   DBG_Cout( endl);
	   if (read<1) break;
	    while((read=fread(&cin,1,1,f)>0)&&(cin!='\xa')); 
           } else { // no digit or X... 
	   }
   } while(read>0); // do
  fclose(f);
  return rV;
}


// fault list reduction

void reduceFL(DDObj *obvod) {
DDWire *fw;
DDGate *fromg;
   if (obvod->FaultList==NULL) { DBG_Cout("Fault list is null!" << endl);  }
   else {
   	for(DDFault *xff=obvod->FaultList;xff!=NULL;xff=xff->next)
   	{


	 if(xff->fw!=NULL) {
		fw=xff->fw;
		if (fw->togate!=NULL) { // gate on right, I can set up dominances
			DDGate *tog=fw->togate;
			int gnot=tog->gTyp&tNOT;
			int doms=(fw->fromwire==NULL)?0:1;
			DDWire *xw;
			switch (tog->gTyp&~tNOT) { // type-w/o-negation
			case tAND: DBG_Cout("typ and: " << tog->name << endl); 
				if (xff->stuckAt==1)  {// only sa1 dominates 
					xff->domini=makeArray<DDFault *>(doms+1); // 0 reserved for dominis to left!?
					xff->outputs=doms+1;
					if (gnot) xff->domini[doms]=tog->outwire->FL->prev; // 0
					else xff->domini[doms]=tog->outwire->FL; //  1
				} break ;;
			case tOR: DBG_Cout("typ: or " << tog->name << endl); 
				if (xff->stuckAt==0)  {// only sa0 dominates 
					xff->domini=makeArray<DDFault *>(doms+1); // 0 reserved for dominis to left!?
					xff->outputs=doms+1;
					if (gnot) xff->domini[doms]=tog->outwire->FL; // 1
					else xff->domini[doms]=tog->outwire->FL->prev; //  0
				} break ;;
			case tXOR: DBG_Cout("typ: xor cannot be reduced:" <<tog->name<<endl); // but is easy to detect...
				 break ;;
			default:;
			} // switch
		} // end if togate!=NULL
		

	   if (xff->fw->fromgate!=NULL) { // check dominances from left
	 	fromg=xff->fw->fromgate; // simplyfying 
	    	DBG_Cout("gate: " << fromg->name << "typ:" << fromg->gTyp << endl); 
		if (xff->ekvf==NULL) xff->ekvf=xff; // self pointing equivalence
		int gnot=fromg->gTyp&tNOT; // negated output
		int fand=(fw->towires==NULL)?0:fw->outputs; // +dominating fan-outs
		DDWire *xw; // simplyfying 
		if (fromg->gTyp==tNOT) { // just negation
			DBG_Cout("typ not: " << fromg->name << endl); 
			// DBG_Print("typ: not \n",fromg->name,fromg->gTyp); 
				xff->domine=makeArray<DDFault *>(fromg->inputs+fand);
				xff->inputs=fromg->inputs+fand;
				for(int i=fand;i<fromg->inputs+fand;i++) {
					xw=fromg->inwires[i-fand];
					if (xff->stuckAt==1) xff->domine[i]=xw->FL;
					else xff->domine[i]=xw->FL->prev;
				} // end for
		} else // typ != tNOT
		switch (fromg->gTyp&~tNOT) {
			case tAND:
			       	DBG_Cout("typ and: " << fromg->name << endl); 
			       	// DBG_Print("typ: and \n",fromg->name,fromg->gTyp); 
				if (((xff->stuckAt==1)&&!gnot)||
				    ((xff->stuckAt==0)&&gnot)) { // dominated via fromgate 
	    					// DBG_Print("sa01: %s typ: %d \n",fromg->name,fromg->gTyp); 
					xff->domine=makeArray<DDFault *>(fromg->inputs+fand);
					xff->inputs=fromg->inputs+fand;
					for(int i=fand;i<fromg->inputs+fand;i++) {
							xw=fromg->inwires[i-fand];
							if (gnot) xff->domine[i]=xw->FL;
							else xff->domine[i]=xw->FL->prev;
					} // end for
				}  // end if
				   else { // ekv s ostatnimi 0/1
					  DBG_Cout("equiv: " <<fromg->inputs << endl); 
					  // DBG_Print("equiv: %d \n",fromg->inputs); 
					  DDFault *pomf,*pom2f;
					  for(int i=0;i<fromg->inputs;i++) {
						// if (xff->stuckAt==0)  but always!
						pomf=fromg->inwires[i]->FL->prev; // 0
						// else pomf=fromg->inwires[i]->FL; // 1 is nonsense
						if (pomf->ekvf==NULL) pomf->ekvf=pomf; // selfishly
						// well, this could be fine, but needs a finish
						pom2f=pomf->ekvf; // switch fault pointers
						pomf->ekvf=xff->ekvf; 
					  	xff->ekvf=pom2f;
					  } // for
				   } // end else
			break;;
			case tXOR: 
				DBG_Cout("typ: xor cannot be reduced" << endl); 
				// DBG_Print("typ: xor cannot be reduced\n",fromg->name,fromg->gTyp); 
			break;;
			case tOR: 
				DBG_Cout("typ or :" << fromg->name << endl); 
				// DBG_Print("typ: or\n",fromg->name,fromg->gTyp); 
				if (((xff->stuckAt==0)&&!gnot)||
				    ((xff->stuckAt==1)&&gnot)) { // dominated via fromgate 
					xff->domine=makeArray<DDFault *>(fromg->inputs+fand);
					xff->inputs=fromg->inputs+fand;
					for(int i=fand;i<fromg->inputs+fand;i++) {
							xw=fromg->inwires[i-fand];
							if (gnot) xff->domine[i]=xw->FL;
							else xff->domine[i]=xw->FL->prev;
					} // end for
				}  // end if
				   else { // ekv s ostatnimi 0/1
					  DBG_Cout("equiv: " << fromg->inputs << endl); 
					  // DBG_Print("equiv: %d \n",fromg->inputs); 
					  DDFault *pomf,*pom2f;
					  for(int i=0;i<fromg->inputs;i++) {
						pomf=fromg->inwires[i]->FL; // 1
						if (pomf->ekvf==NULL) pomf->ekvf=pomf; // selfishly
						// well, this could be fine, but needs a finish
						pom2f=pomf->ekvf; // switch fault pointers
						pomf->ekvf=xff->ekvf; 
					  	xff->ekvf=pom2f;
					  } // for
				   } // end else
				   break;;
			default: ; // unknown gate type...
		} // switch
	   } // end if fromgate!=NULL
	   else if (fw->fromwire!=NULL) { // if it's from fan, it is domining fan-ins
		   	DBG_Cout("fault - fromwire fl=" << fw->fromwire->FL << endl);
		   	// DBG_Print("fault - fromwire fl=%p\n",fw->fromwire->FL);
			if (xff->domini==NULL) {
				xff->domini=makeArray<DDFault *>(1);
				xff->outputs=1;
			}
			if (xff->stuckAt==0) xff->domini[0]=fw->fromwire->FL->prev;
			else xff->domini[0]=fw->fromwire->FL;
	   } // end if fromwire!=NULL

	   // also deal with the fan-ins
	   if (fw->towires!=NULL) { // towires can be only when it is fromgate, and PI also...
			//  towires faults dominate this fault
			if (xff->domine==NULL) {
				xff->domine=makeArray<DDFault *>(fw->outputs);
				xff->inputs=fw->outputs;
			}
			if (xff->stuckAt==0) // setting it up 
			  for(int fi=0;fi<fw->outputs;fi++) xff->domine[fi]=fw->towires[fi]->FL->prev;
			else  // i.e. sa1
			  for(int fi=0;fi<fw->outputs;fi++) xff->domine[fi]=fw->towires[fi]->FL;

			
	   } // end if towires!=NULL
	  // DBG_Print("fault - finish!\n");
	/*	
		for(DDFault *pf=xff->ekvf;(pf!=NULL)&&(pf->fw!=xff->fw);pf=pf->ekvf)	
	    	DBG_Print("ekv: %s / %d -> (%s) ekv:%s (%p)\n",pf->fw->name,pf->stuckAt,pf->fw->FL->fw->name,pf->ekvf->fw->name,pf->ekvf->fw); 
		
		for(DDFault *pf=fw->FL;(pf!=NULL)&&(pf->fw==fw->FL->fw);pf=pf->prev)	
	    	DBG_Print("same: %s / %d -> (%s)\n",pf->fw->name,pf->stuckAt,pf->fw->FL->fw->name); 
	   }
	 }
   	}
	*/
	  } // fw!=NULL
	 } // end for faults
   	for(DDFault *xff=obvod->FaultList;xff!=NULL;xff=xff->next) // deactivate dominated and equivalent
   	{
	 if ((xff->fw!=NULL)&&(xff->active!=0)) { // not deactivated yet and not empty
		if (xff->domine==NULL) {
		 if ((xff->ekvf!=NULL)&&(xff->ekvf!=xff)) { // it has some equiv. fault(s)
	 	 	 DDFault *fi=NULL;
			 for(fi=xff->ekvf;fi!=xff;fi=fi->ekvf)
				 if (fi->domine!=NULL) { // ekv is dominated -> deactivate
					 fi->active=0;
					 break;
				 }
			// and deactivate all the equiv. 
			 for(DDFault *fj=fi->ekvf;fj!=fi;fj=fj->ekvf) fj->active=0; 
		 }
		} else xff->active=0;
	 } // if NULL or active=0
	} // end for faults
   } // FL!=NULL
}

void printFL(DDObj *obvod,int full) {
   if (obvod->FaultList==NULL) cerr << "Fault list is null!\n";
   for(DDFault *xff=obvod->FaultList;xff!=NULL;xff=xff->next)
   {
     if (dbg_print) {
	if (xff->fg!=NULL) { // old style FL
	    if (xff->pio) printf("%s / %d (%d, PIN)\n",xff->fg->inwires[xff->index]->name,xff->stuckAt,xff->index); 
	    else printf("%s / %d (%d. at %s - %p)\n",xff->fg->inwires[xff->index]->name,xff->stuckAt,xff->index,xff->fg->name,xff->fg); }
	if(xff->fw!=NULL) { // new, based on wires only
		if (xff->fw->togate!=NULL)
		printf("%s -> %s  / %d  (%p:%p) pio:%d act:%d... \t g%p e%p dm%p di%p\n",xff->fw->name,xff->fw->togate->name,xff->stuckAt,xff->fw,xff,xff->pio,xff->active,xff->fg,(xff->ekvf==NULL)?(NULL):xff->ekvf,(xff->domine==NULL)?(NULL):xff->domine[0],(xff->domini==NULL)?(NULL):xff->domini[0]); 
		 else
		// printf("%s / %d (%p) \n",xff->fw->name,xff->stuckAt,xff->fw); 
		 printf("%s  / %d  (%p:%p) pio:%d act:%d... \t g%p e%p dm%p di%p\n",xff->fw->name,xff->stuckAt,xff->fw,xff,xff->pio,xff->active,xff->fg,xff->ekvf,xff->domine?xff->domine[0]:NULL,xff->domini?xff->domini[0]:NULL); 
	}
     } else
     { // standard print
	if ((xff->fw!=NULL)&&((xff->active==1)||full)) { // wires only
		if (xff->fw->togate!=NULL)
		printf("%s->%s  /%d\n",xff->fw->name,xff->fw->togate->outwire->name,xff->stuckAt); 
		 else
		 printf("%s  /%d\n",xff->fw->name,xff->stuckAt); 
	}
     }	     
   } // end for
}


// --------------------- basic ATPG --------------------
int setBackG(DDGate *dg, int &check);

int setBackW(DDWire *dw, int &check) {
	if (dw->fromgate!=NULL)  return setBackG(dw->fromgate,check);
	else if (dw->fromwire!=NULL) return setBackW(dw->fromwire,check);
	else return 1; // it's a PIN
}

int setBackG(DDGate *dg, int &check) {
int back=1;
	for (int i=0;(i<dg->inputs)&&back;i++) back=back&&setBackW(dg->inwires[i],check);
return back;
}

int sensG(DDGate *dg, int &check);

int sensW(DDWire *dw, int &check)  {
	if (dw->togate!=NULL) return sensG(dw->togate,check); 
	else if (dw->towires!=NULL) {
		for(int i=0;i<dw->outputs;i++)
		 if (sensW(dw->towires[i],check)) return 1;
	}
	else return setBackW(dw,check);
return 0;
}

int sensG(DDGate *dg, int &check)  {
	if (dg->outwire!=NULL) return sensW(dg->outwire,check);
	else // setBackG(dg,int); Error! no outwire from gate!
return 0;
}

// --- getting to work
void clearStates(DDObj *obvod,int n);

int setForwG(DDGate *dg,DDWire *iw,int &check,int nval);
int setForwW(DDWire *dw,DDWire *iw,int &check,int &nval);
int setBackG(DDGate *dg, int &check,int nval);

int setBackW(DDWire *dw, int &check, int nval) {
int back=1,chval=0;
 DBG_Cout( "-backW "<< dw->name << ":" << nval << endl);
	if ((dw->value!=vUndef)) { // already set
		if (dw->value!=nval) return 0; // it is set OK? if yes, continues to PINs
	} else { // new trace
		// dw->state=pOpen;
		dw->value=nval;
		chval=1;
		DBG_Cout( dw->name << ":=" << nval << endl);
	}
	if (dw->fromgate!=NULL) back=setBackG(dw->fromgate,check,nval); 
	else if (dw->fromwire!=NULL) {
		back=setForwW(dw->fromwire,dw,check,nval);
		if (back) back=setBackW(dw->fromwire,check,nval);
	} else back=1; // it's a PIN
if (!back) DBG_Cout( "!backW!"<< endl); 
else DBG_Cout( "=backW=" << endl);
if (chval&&!back) dw->value=vUndef;
return back;
}

int setBackG(DDGate *dg, int &check, int nval) {
int back=1,chval=0;
int otval=vUndef; // value of other inputs than leading one 
int xory=0;
 DBG_Cout( "-backG " << dg->name << ":" << nval << endl);
 	if(dg->state==pUndef)
	 if (dg->un_checked!=check) {
		dg->un_checked=check;
		dg->value=nval;
		chval=1;
		dg->state=pOpen;
		DBG_Cout( dg->name << "o=" << nval << endl);
	} // if if
	switch (dg->gTyp) {
			case tAND: if (nval==1) otval=1; nval=0; break ;;
			case tNAND: if (nval==0) otval=1; nval=0; break ;;
			case tNOT: otval=1-nval; break ;;
			case tOR: if (nval==0) otval=0; nval=1; break ;;
			case tNOR: if (nval==1) otval=0; nval=1; break ;;
			case tXNOR: xory=2; break;; // know nothing yet
			case tXOR: xory=1; break;;
	} // switch
	DDWire *inW;
	if (xory) {
		int known=vUndef;
		if (dg->inwires[1]->value!=vUndef) known=1;
		if (dg->inwires[0]->value!=vUndef) known=0;
	        if (known!=vUndef) { // we know exact value of another input  !
				inW=dg->inwires[known];
				otval=inW->value xor nval; // 
				if (xory==2) otval=1-otval;
		        	DBG_Cout( "xor setting:" << otval << endl);
				back=setBackW(dg->inwires[1-known],check,otval);
		} else { // nothing set, we have 2 options:
		        DBG_Cout( "xor - 2 variants"<< endl);
			if (xory==2) nval=1-nval;
			int check2=check;
			check2++;
			if (nval) {  // needs decision which one (0 or 1) first
				back=setBackW(dg->inwires[0],check2,0);
				if (back) back=setBackW(dg->inwires[1],check2,1);
				if (!back) {
					clearStates(mujobv,check2);
					back=setBackW(dg->inwires[0],check2,1);
					if (back) back=setBackW(dg->inwires[1],check2,0);
					if (!back) clearStates(mujobv,check2);
				}
			} else { // !nval
				back=setBackW(dg->inwires[0],check2,0);
				if (back) back=setBackW(dg->inwires[1],check2,0);
				if (!back) {
					clearStates(mujobv,check2);
					back=setBackW(dg->inwires[0],check2,0);
					if (back) back=setBackW(dg->inwires[1],check2,0);
					if (!back) clearStates(mujobv,check2);
				} // if
			} // else
		} // else
		// if (back) dg->state=pClosed; // xor always closed if set - now?
	}
	else { // not xors
	int others=0;
	DBG_Cout( "search inputs"<< endl);
	for (int i=0;(i<dg->inputs)&&(back);i++) { 
		inW=dg->inwires[i];
		DBG_Cout( "input " << i << endl);
		DBG_Cout( "otval " << otval << ", others: " << others <<endl);
		if (otval!=vUndef) back=setBackW(inW,check,otval);
		else if (inW->value!=vUndef) {
			if (inW->value==nval) { // conditions are met
				if (setBackW(inW,check,nval)) {// is it right one?
					others=0;  // no need for another 1
					break;  
				}
				else {  // could not set! possibly search undefined
					others=1; 
					// inW->value=1-nval; // bad thing to do this
				} 
			} // if 
		     } else others=1; // if - an undef, possibly search other
	} // for
	if (others) { // just 1 of all needs to be set, some decision in future needed
		int check2=check;
		check2++;
		for (int i=0;(i<dg->inputs);i++) { 
			DBG_Cout( "setting:" << i << endl);
			inW=dg->inwires[i];
			if (inW->value==vUndef) {
				if (back=setBackW(inW,check2,nval)) break;
				clearStates(mujobv,check2); // else
			}
		}//for
	} // others
	else { // not 1 but all -> close gate
		if (back) dg->state=pClosed; // -- but we won't get sensitive...
	}
	} // not xors
if(!back) DBG_Cout( "!backG!"<< endl); 
else DBG_Cout( "=backG=" << endl);
if (chval&&!back) dg->value=vUndef;
return back;
}

int setForwG(DDGate *dg,DDWire *iw,int &check,int nval) {
int close=1,chval=0,back=1;
int propag=0,gval=vUndef;
DBG_Cout( "+setForwG " << dg->name << ":" << dg->value << ":" << nval << endl);
	if (dg->state!=pClosed)  { // 1.no all ins are specd,
	for(int i=0;i<dg->inputs;i++) 
		if (dg->inwires[i]->value==vUndef) { // at least 1 unopened input
			close=0;
			DBG_Cout( "no closing " << endl);
			break;
		} // if
	} // end if !closed
	else close=0;
		close=close&&(dg->state!=pOpen);
		   switch (dg->gTyp) {
			case tAND: 
				if (nval==0) gval=0; // Ad 2
				else if (close) gval=1; 
				break ;; // Ad 1
			case tNAND:  // 
				if (nval==0) gval=1;  
				else if (close) gval=0; 
				break ;;
			case tNOT: gval=1-nval; break ;;
			case tOR:  if (nval==1) gval=1;  
				else if (close) gval=0;
				   break ;;
			case tNOR: if (nval==1) gval=0; 
				else if (close) gval=1;
				   break ;;
			case tXNOR:  if (close)  {
				gval=dg->inwires[0]->value xor dg->inwires[1]->value; 
				     }
				break;; // know nothing, or need to recalc both vals
			case tXOR: if (close)  {
				gval=dg->inwires[0]->value xor dg->inwires[1]->value; 
				   }
				break;;
		   } // end - the switch
		if (dg->state==pUndef) { //  2.no clear output yet
		  if (gval!=vUndef) {
			       	dg->value=gval; // value can be set
				chval=1;
				dg->un_checked=check;
				DBG_Cout( dg->name << "o=" << gval << endl);
				dg->state=pOpen;
				DBG_Cout( "propag time" << endl);
				back=setForwW(dg->outwire,NULL,check,gval);
				// if (back) dg->outwire->state=pSens;
		  } // gval!=undef
		} // if state==pUndef
		else 
			if ((gval!=vUndef)&&(dg->state!=pUndef)) back=(dg->value==gval);
			else back=1;
			
		if (close&&back) { // close, all inputs now defined.
			DBG_Cout( "closing time" << endl);
			dg->state=pClosed; 
		} // if 
if (chval&&!back) dg->value=vUndef;
if(!back) DBG_Cout( "!SetForwG!"<< endl); 
else DBG_Cout( "=SetForwG=" << endl);
return back;
}

int setForwW(DDWire *dw,DDWire *iw,int &check,int &nval) {
int back=1,chval=0;
DBG_Cout( "+setForwW " << dw->name << "=" << dw->value << ":" << nval << endl);
if (dw->value==vUndef) { // not open
	// dw->state=pOpen; // open
	dw->value=nval;
	dw->un_checked=check;
	chval=1;
	DBG_Cout( dw->name << ":=" << nval << endl);
	if(dw->towires!=NULL) { // fan
		for(int i=0;(i<dw->outputs)&&back;i++) {
			if (dw->towires[i]!=iw) back=setForwW(dw->towires[i],NULL,check,nval);
		}
	}
	else  // no fan
		if (dw->togate!=NULL) back=setForwG(dw->togate,dw,check,nval); // else PO
} else back=(dw->value==nval);
if(!back) DBG_Cout( "!SetForwW!"<< endl); 
else DBG_Cout( "=SetForwW=" << endl);
if (chval&&!back) dw->value=vUndef;
return back;
}

int sensG(DDGate *dg, DDWire *iw,int &check,int nval); // nval not &nval!

int sensW(DDWire *dw, int &check,int &nval)  {
int back=1;
int origval;
DBG_Cout( ":sensW " <<dw->name <<"=" << dw->value << ":" << nval << endl);
 if ((dw->value!=vUndef)&&(nval!=dw->value)) {
	DBG_Cout( "!sensW!:" << dw->value << endl);
	return 0; 
 }
	origval=dw->value;	
// should not be open when making sensitive, only fan-out with nval
	// dw->un_checked=check; // this round ???
 	if (origval==vUndef) {
	 dw->value=nval;
	 dw->un_checked=check;
	 DBG_Cout( dw->name << ":=" << nval << endl);
	 if (dw->fromwire!=NULL) back=setForwW(dw->fromwire,dw,check,nval); 
	}
	 dw->state=pSens;
	if (back) {
	if (dw->togate!=NULL) back=sensG(dw->togate,dw,check,nval); 
	else if (dw->towires!=NULL) {
		if (origval==vUndef) for(int i=0;i<dw->outputs;i++) setForwW(dw->towires[i],NULL,check,nval); // we don't test, can't be in collision
		// just set up what we know
		int check2=check;
		check++;
		for(int i=0;i<dw->outputs;i++) { // !!! point of backtrack ! - decision
		 if (back=sensW(dw->towires[i],check2,nval)) break;
		 clearStates(mujobv,check2);
		}
	}
	else back=setBackG(dw->fromgate,check,nval); // backward setup
	}
	// dw->un_checked=check-1;
if(!back) DBG_Cout( "!SensW!"<< endl); 
else DBG_Cout( "=SensW=" << endl);
return back;
}

int sensG(DDGate *dg, DDWire *iw,int &check,int nval)  { // nval not &nval!
int back=1;
int xory=0;
int otval=vUndef; // value of other inwires
 DBG_Cout( ":sensG " << ":" << nval <<dg->name<< endl);
  if (dg->state!=pClosed) {
	if (dg->outwire!=NULL) {
		dg->state=pOpen;
		if (dg->un_checked==0) dg->un_checked=check;
		switch (dg->gTyp) {
			case tAND: dg->value=nval; otval=1; break ;;
			case tNAND: dg->value=1-nval; otval=1; break ;;
			case tNOT: dg->value=1-nval; otval=0; break ;;
			case tOR: dg->value=nval; otval=0; break ;;
			case tNOR: dg->value=1-nval; otval=0; break ;;
			case tXNOR: dg->value=1-nval; xory=2; break;;
			case tXOR: dg->value=nval; xory=1; break;;
		} // switch
		DDWire *inW;
		if (xory) {
			int known=vUndef;
			int check2=check;
			if (dg->inwires[1]==iw) known=1;
			else known=0; // hope it equals
			if (dg->inwires[1-known]->value!=vUndef) // we have all now
				dg->value=dg->inwires[1]->value xor dg->inwires[0]->value;
			else {
				dg->value=1;
				// !!! this is a heuristic hack !!!
				check2++;
				back=setBackW(dg->inwires[1-known],check2,0); // 0 first
				if (!back)  {
					clearStates(mujobv,check2); // need this!
					dg->value=1-dg->value;	
					back=setBackW(dg->inwires[1-known],check2,1); // then 1
					if (!back) {
					       	clearStates(mujobv,check2); // need this!
					}
				}
			}
			int i=dg->value;
			if (back) {
				check2++;
				back=back&&sensW(dg->outwire,check2,i);
				if (!back) {
				       	clearStates(mujobv,check2); // need this!
					i=dg->value=0;
					back=back&&sensW(dg->outwire,check2,i);
				}
			}
		}//xory 
			else  { // ostatni
		DBG_Cout( dg->name << "o=" << dg->value << endl);
		DBG_Cout( "check inputs" << endl);
		for(int i=0;i<dg->inputs;i++) {// at least check inputs 
			inW=dg->inwires[i];
			DBG_Cout( "input:" << i << ":" << inW->name << endl);
			if (inW!=iw) { 
				if(inW->value!=vUndef) { 
					if (inW->state!=pSens) back=(inW->value==otval); 
					else back=(inW->value==nval); // !!!
// cout << "psens?:" << inW->state << endl;
	break; 
				}  else
				// if (!(back=setForwW(inW,inW,check,otval))) break;
					 if (!(back=setBackW(inW,check,otval))) break;
				// !!! cannot do here ! will loose info about forking
				// could do setforw... 
			}	
		} // for
		int i=dg->value;
		back=back&&sensW(dg->outwire,check,i);
			} // else
	} // else setBackG(dg,int); Error! no outwire from gate!
 } // end if !closed
 else 
 {
		switch (dg->gTyp) {
			case tAND: otval=1; break ;;
			case tNAND: otval=1; break ;;
			case tNOT: otval=0; break ;;
			case tOR: otval=0; break ;;
			case tNOR: otval=1; break ;;
		}
		if ((dg->gTyp==tXOR)||(dg->gTyp==tXNOR)); // "allways" sensitive 
		else { // check all other inputs
			for(int i=0;(i<dg->inputs)&&back;i++)
				if (dg->inwires[i]!=iw) 
					back=back&&(dg->inwires[i]->value==otval);
		}
		int i=dg->value;
		back=back&&sensW(dg->outwire,check,i);
}
if(!back) DBG_Cout( "!SensG!"<< endl); 
else DBG_Cout( "=SensG=" << endl);
return back;
}


// clear circuit actual status

void clearState(DDWire *w) {
w->value=vUndef;
w->state=pUndef;
w->un_checked=0;
	if(w->towires!=NULL)
		for(int i=0;i<w->outputs;i++) clearState(w->towires[i]);
	if(w->togate!=NULL) {
		w->togate->state=pUndef;
		w->togate->value=vUndef;
		w->togate->un_checked=0;
		clearState(w->togate->outwire);
	}
}

void clearState(DDWire *w,int &n) {
if (w->un_checked==n) { 
	w->value=vUndef;
	w->un_checked=0;
}
	if(w->towires!=NULL)
		for(int i=0;i<w->outputs;i++) clearState(w->towires[i],n);
	if(w->togate!=NULL) {
		if(w->togate->un_checked==n)  {
			w->togate->state=pUndef;
			w->togate->value=vUndef;
			w->togate->un_checked=0;
		}
		clearState(w->togate->outwire,n);
	}
}

int *getInputs(DDObj *obvod) {
int x;
int *V=makeArray<int>(obvod->inputs);
	for(int i=0;i<obvod->inputs;i++) 
		if ((x=obvod->Inputs[i]->value)>=0) V[i]=x;
		else if ((x=obvod->Inputs[i]->svalue)>=0) V[i]=x;
		else V[i]=vUndef;
return V;
}

void printVector(int *V) {
int x;
if (V!=NULL)
	for(int i=0;i<mujobv->inputs;i++) 
		if ((x=V[i])>=0) cout << x;
		else cout << "X";
		cout << endl;
}

void printVector(int *V,int size) {
int x;
if (V!=NULL)
	for(int i=0;i<size;i++) 
		if ((x=V[i])>=0) cout << x;
		else cout << "X";
}

void printOutputs(DDObj *obvod) {
int x;
//	for(int i=0;i<obvod->inputs;i++) cout << (obvod->Inputs[i]->value) << ":";
	for(int i=0;i<obvod->outputs;i++) 
		if ((x=obvod->Outputs[i]->value)>=0) cout << x;
		else if ((x=obvod->Outputs[i]->svalue)>=0) cout << x;
		else cout << "X";
}
void printInputs(DDObj *obvod) {
int x;
//	for(int i=0;i<obvod->inputs;i++) cout << (obvod->Inputs[i]->value) << ":";
	for(int i=0;i<obvod->inputs;i++) 
		if ((x=obvod->Inputs[i]->value)>=0) cout << x;
		else if ((x=obvod->Inputs[i]->svalue)>=0) cout << x;
		else cout << "X";
}
void clearStates(DDObj *obvod) {
	for(int i=0;i<obvod->inputs;i++) clearState(obvod->Inputs[i]);
}

void clearStates(DDObj *obvod,int n) {
DBG_Cout( "clear states" << endl);
	for(int i=0;i<obvod->inputs;i++) clearState(obvod->Inputs[i],n);
}

void printFault(DDFault *xff) {
	if (xff->fw!=NULL) { // wires only
		if (xff->fw->togate!=NULL)
		printf("%s->%s  /%d\n",xff->fw->name,xff->fw->togate->outwire->name,xff->stuckAt); 
		 else
		 printf("%s  /%d\n",xff->fw->name,xff->stuckAt); 
	}
}

// --- start-up "interface"

int testDomini(DDFault *xff) {
DDFault *fd;
int i;
DBG_Cout( "+Dominuje:" << xff->outputs << endl);
	for(i=0;i<xff->outputs;i++) {
		if (dbg_print) printFault(xff->domini[i]);
		xff->domini[i]->active=1;
		xff->active=0;
	}
DBG_Cout( "-Dominuje:" << endl);
return (i>0);
}

int makeTest2(DDFault *xff) {
DDWire *fw=xff->fw;
int check=1,nval,ok;
	nval=(xff->stuckAt==1)?0:1;
	// check=xff->fw->un_checked+1;
	ok=(sensW(fw,check,nval)); // printf("OK\n");
	if (ok) xff->found=1;
return ok;
}

// ------------ usin 4 value logic ----------------

logic4Set &getIn4SetW(DDWire *dw, int &check,int val,int sval,logic4Set &sset);

logic4Set& test4W(DDWire *fw,int &check,int value,logic4Set *crossval) {
logic4Set pom1,pom2;
logic4Set vv1,vv2;
logic4Set sset1,sset2;
logic4Set *pom=new logic4Set;
if (crossval!=NULL) *pom=*crossval;
DDWire *dw;
fw->un_checked=check;
DBG_Cout( "4 init:" << fw->name << " v:" << value <<" ch:" <<check << endl);
	if (fw->togate!=NULL) {
		DBG_Cout( "gate" << endl);
		DDGate *dg=fw->togate;
		int xory=0;
		int sval=0,inval=0,outval; // xor defaults
		int gnot=(dg->gTyp&tNOT);
		if(gnot) outval=1-value; else outval=value;
		switch((dg->gTyp&~tNOT)) {
			case tAND: inval=1; sval=value+2; break;;
			case tOR: inval=0; sval=value+2; break;;
			case tXOR: xory=1; break;;
		} // switch
		if (xory) { 
			DBG_Cout( "xory" << endl);
			if (dg->inwires[0]!=fw) dw=dg->inwires[0];
			else dw=dg->inwires[1];
			pom1=getIn4SetW(dw,check,inval,0,sset1);
			if (crossval!=NULL) pom1=pom1*(*crossval);
			if (!pom1.isEmpty()) { 
				vv1=test4W(dg->outwire,check,outval,&pom1);
			}
			pom2=getIn4SetW(dw,check,1-inval,0,sset2);
			if (crossval!=NULL) pom2=pom2*(*crossval);
			if (!pom2.isEmpty()) { 
				vv2=test4W(dg->outwire,check,1-outval,&pom2);
			}
			*pom=vv1+vv2;
		} else { // not xory
			DBG_Cout( "not xor" << endl);
			int empty=0;
			if (crossval!=NULL) pom2=*crossval;
			for(int i=0;i<dg->inputs;i++) {
				dw=dg->inwires[i];
				if (dw!=fw) {
						DBG_Cout( "setting:" << i << endl);
						pom1=getIn4SetW(dw,check,inval,sval,sset1);
						if (dbg_print) { cout << "sset1=";
						sset1.print(); }
						if (dbg_print) { cout << "pom1=";
						pom1.print(); }
						if (dbg_print) { cout << "pom2=";
						pom2.print(); }
						if (dbg_print) { cout << "pom3=";
							logic4Set *pom3=new logic4Set;;
							*pom3=(pom2*(pom1+sset1));
							pom3->print(); }
						if (pom2.isEmpty()) pom2=(pom1+sset1);
						else pom2=(pom2*(pom1+sset1));
						if (dbg_print) { cout << "pom2=";
						pom2.print(); }
						// if (empty=(pom2.isEmpty()&&sset1.isEmpty()))
						if (empty=(pom2.isEmpty()))
							break;
				}
			} // for
			if (!empty) *pom=test4W(fw->togate->outwire,check,outval,&pom2);
			else *pom=pom2;
		} // else xory
	} // gate
	if (fw->towires!=NULL) {
	DBG_Cout( "to wires" << endl);
	 for (int i=0;i<fw->outputs;i++) {
		/*
		if (dbg_print) { cout << "towires: pom2=";
				pom2.print(); 
				cout << "crossval="; crossval->print(); }
		*/
		pom1=test4W(fw->towires[i],check,value,crossval);
		pom2=(pom2+pom1);
	 }
	 *pom=pom2;
	} // end towires 
	else { // POUT
		// ? don't need yet
	}
if (dbg_print) pom->print();
fw->un_checked=check-1;
DBG_Cout( "4 return:" << fw->name << endl);
return *pom;
}


// get set of input values to reach "val" value on gate "dg"
logic4Set &getIn4SetG(DDGate *dg, int &check,int val, int sval,logic4Set &sset) {
int allval=vUndef, otval=vUndef, allsval=vUndef, otsval=vUndef;
int sval2=vUndef,xory=vUndef;
DBG_Cout( "init:" << dg->name  << " v:" << val <<" s:" << sval << " ch:" <<check << endl);
logic4Set *pom=new logic4Set,pom1,pom2;
logic4Set sset1,sset2;
DBG_Cout( "G if 1" << endl);
if (sval) sval2=sval-2;
	switch (dg->gTyp) {
		case tAND: if (val) { 
			 	allval=1; 
				if (sval) allsval=sval2; 
			}
			else {
				otval=0; 
				if (sval) otsval=sval2;  
			}
			break ;;
		case tNAND: if (!val) { 
			 	allval=1; 
				if (sval) allsval=!sval2; 
			}
			else {
				otval=0; 
				if (sval) otsval=!sval2;  
			}
			break ;; 
		case tNOT: 
			allval=!val; if (sval) allsval=!sval2; break ;;
		case tOR: if (!val) { 
			 	allval=0; 
				if (sval) allsval=sval2; 
			}
			else {
				otval=1; 
				if (sval) otsval=sval2;  
			}
			break ;;
		case tNOR: if (val) { 
			 	allval=0; 
				if (sval) allsval=!sval2; 
			}
			else {
				otval=1; 
				if (sval) otsval=!sval2;  
			}
			break ;;
		case tXOR: xory=1; break;;
		case tXNOR: xory=2; break;;
	}
	if (xory!=vUndef) {// it's a xor, special rules apply!
				DBG_Cout( "xory" <<endl);
				int nsval2;
				if (sval) { nsval2=3-sval2; sval2+=2; }
				else { nsval2=0; sval2=0; } // sensitive and negation
				if (xory=2) val=1-val;
				// here I need both 0,1 for any result value
				pom1=getIn4SetW(dg->inwires[0],check,0,sval2,sset1);
				pom2=getIn4SetW(dg->inwires[1],check,1,nsval2,sset2);
				logic4Set pom3,pom4;
				logic4Set sset3,sset4;
				pom3=getIn4SetW(dg->inwires[0],check,1,nsval2,sset3);
				pom4=getIn4SetW(dg->inwires[1],check,0,sval2,sset4);

				if (sval2==3) sset=((pom1*sset1)+(pom2*sset2)); // sensitive 1
				else if (sval2==2) sset=((pom3*sset3)+(pom4*sset4)); // sens. 0
				// sset=sset.selection(10); // pruning try
				if (val) *pom=((pom1*pom2)+(pom3*pom4)); // for 1
				else *pom=((pom1*pom4)+(pom2*pom3)); // for 0
		} else // non xor gates
		{
			if (sval) { allsval+=2; otsval+=2; }
			else { allsval=0; otsval=0; }
			if (allval!=vUndef) { // all values needs to be se to "allval"
				DBG_Cout( "allval" <<endl);
				int not_all=0;
				for (int i=0;i<dg->inputs;i++) { // need to set all values to allval, except for sensitive values if any
				  pom1=getIn4SetW(dg->inwires[i],check,allval,allsval,sset1);
				  if (!sset1.isEmpty()) { // sensitive
					   if (i==0) sset2=sset1;
					   else sset2=sset2*pom1+(sset1*pom2)+sset2*sset1;
					   // !!! 3 sets, vals*sens, sens*previous, sens*sens 
					   if (pom1.isEmpty()) not_all=1;
				  } 
				  else  // not sens.
				  {
				     sset2=sset2*pom1; // empty until 1. sensitive
				     if ((i!=0)&&(pom1.isEmpty())) {
					     not_all=1;
					     break; // failed to found anything
				     }
				  }
				  // sset2=sset2.selection(10);// pruning try
				  if (i==0) pom2=pom1; // 1. to full
				  else pom2=pom2*pom1; // next to full
				// pom2=pom2.selection(10); // pruning try
				} // for
				if (!not_all) *pom=pom2;
			} else
			if (otval!=vUndef) { // some other value is needed
				DBG_Cout( "otval" <<endl);
				logic4Set pom3,pom4,sset3;
				int not_ot=0; // means there could be no chance to set 1-otval
				for (int i=0;i<dg->inputs;i++) { // set desired inputs
				  pom1=getIn4SetW(dg->inwires[i],check,otval,otsval,sset1);
				  if (!not_ot) { // we need this! in case of sens input only
				   pom3=getIn4SetW(dg->inwires[i],check,1-otval,0,sset3);
				   if (!sset1.isEmpty()) { // 1-val could be set, add to sets
					  sset2=sset1*pom4+sset1*sset2;
					  // sset2=sset1+sset2+sset2*sset1;

				   } else {
				    if (pom3.isEmpty()) not_ot=1;
				    sset2=sset2*pom3;
				   }
				    // sset2=sset2.selection(10); // pruning try
				    pom4=pom4*pom3; 
				    if(i==0)  pom4=pom3;
				  } // not_ot
				  pom2=pom2+pom1;
				  // pom2=pom2.selection(10);// pruning try
				} // for
				*pom=pom2;
			}
		}

DBG_Cout ("sset:" << endl); 
DBG_DO(sset2.print());
DBG_Cout ("retur:" << endl); 
DBG_DO(pom->print());
DBG_Cout("G return" << endl); 

sset=sset2;
return *pom;
}


// get set of input values to reach "val" value on wire "dw"
logic4Set &getIn4SetW(DDWire *dw, int &check,int val,int sval,logic4Set &sset) {
logic4Set *pom4Set=new logic4Set;
logic4Set *PINs;
DBG_Cout( "init " << dw->name << " v=" << val << " s=" <<sval  << " wch:" <<dw->un_checked << " ch:" <<check << endl);
PINs=dw->PINs;
DBG_Cout( "if 1" << endl);
if (PINs[val].isEmpty()&&(dw->un_checked!=check))  { // not sensitive
// if (PINs[val].isEmpty()&&(dw->state!=pSens))  {
DBG_Cout( "if 2" << endl);
 if (dw->fromgate!=NULL) 
	PINs[val]=getIn4SetG(dw->fromgate,check,val,sval,PINs[sval]);
 else if (dw->fromwire!=NULL) 
	PINs[val]=getIn4SetW(dw->fromwire,check,val,sval,PINs[sval]);
      else if (dw->cpin>=0) PINs[val].makePIN(dw->cpin,val); // primary input 
      // I need no of this pin - cpin
 *pom4Set=(PINs[val]);
} else { // not empty, return already found value
DBG_Cout( "else 1" << endl);
	if (dw->un_checked==check) { 
	// if (dw->state==pSens) { 
		DBG_Cout ("elif 1" << endl);
		sset=dw->PINs[sval]; 
	}
	else { 
		DBG_Cout( "elel 1" << endl);
		*pom4Set=(PINs[val]); 
		DBG_Cout ("elel s:" << sval << endl);
		if (sval) sset=dw->PINs[sval]; 
	} 
	// ! operator= should be changed not to copy pointers only >?
}
if (dbg_print) { 
 pom4Set->print(); 
 DBG_Cout("return" << endl);
}
 return *pom4Set;
}

// ------------ test start procedures ----------------
//
int makeTest(DDFault *xff) {
DDWire *fw=xff->fw;
logic4Set M,N;
logic4Set *x;
int check=1,nval,ok;
	nval=(xff->stuckAt==1)?0:1;
	// ok=(test4W(fw,check,nval)); 
	x=new logic4Set;
	// cout << "1. krok" << endl;
	// M=getIn4SetW(fw,nval,0,N);
	*x=getIn4SetW(fw,check,nval,0,N);
	M=(test4W(fw,check,nval,x));
	M.print();
	N.print();
	ok=0;
	if (ok) xff->found=1;
return ok;
}

int makeTestX(DDFault *xff);

int **makeTestVectorsS(DDObj *obvod) {
int ok;
   VECT=makeArray<int*>(max_vectors);
   allvect=0;
   if (obvod->FaultList==NULL) printf("Fault list is null!\n");
   else {
	DBG_Cout( "------------------------------------"<< endl);
	clearStates(obvod);
	DDFault *A;
	A=obvod->FaultList->getActive();
	DBG_Cout ("fault:" << A<< endl);
	printFault(A);
	DBG_Cout( "make test "<< endl);
	ok=makeTestX(obvod->FaultList->getActive());
	A->active=0;
   } // end for faults
   // return new int[1];
return VECT;
}

int **makeTestVectors(DDObj *obvod) {
int ok;
   VECT=makeArray<int*>(obvod->wires*max_vectors);
   allvect=0;
   DBG_Cout( "clear states "<< endl);
   clearStates(obvod);
   	if (obvod->mask!=NULL) {
	   obvod->setVector(obvod->mask); // clear changes
 	   int *ov=obvod->Simulate();
	   printVector(obvod->mask,obvod->inputs);
	   cout << " ";
	   printVector(ov,obvod->outputs);
	   cout << endl;  
	} 
   if (obvod->FaultList==NULL) printf("Fault list is null!\n");
   else 
   for(DDFault *xff=obvod->FaultList;xff!=NULL;xff=xff->next) 
    if ((xff->fw!=NULL)&&(xff->active)&&(!xff->found)) { // all active faults
	DBG_Cout( "------------------------------------"<< endl);
	printFault(xff);
	DBG_Cout( "clear states "<< endl);
	// clearStates(obvod);
	DBG_Cout( "make test "<< endl);
	/*
   	if (obvod->mask!=NULL) {
	   obvod->setVector(obvod->mask); // clear changes
 	   int *ov=obvod->Simulate();
	   // printVector(obvod->mask,obvod->inputs);
	   // cout << " ";
	   // printVector(ov,obvod->outputs);
	   // cout << endl;  
	} */
	ok=makeTestX(xff);
	/*
	if (dbg_print) { 
		cout << "print inputs:"<< ok << endl;
		if (ok) printFault(xff); 
	}
	if (ok) {
		cout << "1:"; // we have just 1 now...
		printInputs(obvod);
		cout << " ";
		printOutputs(obvod);
		cout << endl;
	}
	else if (testDomini(xff)) xff=obvod->FaultList;
	DBG_Cout( "next fault"<< endl);
	*/
   } // end for faults
   // return new int[1];
return VECT;
}


// ------------ cyclic backtrack procedures ----------------
//
int getInSet(DDWire *dw, int nval, DDGate *getBack,int sval, DDGate *getsBack);
int getToSet(DDWire *dw, int nval);
int getInG2(DDGate *dg,int sens);

int getInG(DDGate *dg, int nval, DDGate *getBack,int sval,DDGate *getsBack) {
DBG_Cout("getInG:" << dg->name << endl);
	// get input value, and try to set all possible combinations
int bnval=nval,bsval=sval; // backup
int otval=vUndef; // all other inputs 
int otsval=vUndef; // inc. sensitive
int i=vUndef;
int succ=0;
int xorit;
if (dg->state==pUndef) { // not defined yet
// dg->ins=0;
loops++;
if (kit>0) if (loops>kit) return 0;
dg->state=pOpen;
dg->value=nval;
dg->svalue=sval;
if (dg->backG!=dg) dg->backG=getBack; // musim vedet kam dal zpet, dal bude toto hradlo
if (getBack==NULL) getBack=dg;
do {
nval=bnval;
sval=bsval;
DBG_Cout("i:" << i << " nv:" << nval <<" ot:" <<otval << " sval" <<sval << " otsv:" << otsval << endl);
i=dg->getFreeInput(i,nval,otval,sval,otsval); // get input values
DBG_Cout("i:" << i << " nv:" << nval <<" ot:" <<otval << " sval" <<sval << " otsv:" << otsval << endl);
if (i>=0) { // i.e.  an input found
	succ=1;
	if (otval==vUndef) { // only 1 is enough
		dg->vmask=i;
		xorit=dg->connected;
		if (nval!=vUndef) getInSet(dg->inwires[i],nval,getBack,sval,dg);
		else {
			if (vectors<max_vectors)
			if (sval!=vUndef) getInSet(dg->inwires[i],otsval,dg,sval,dg);
		}
		dg->connected=xorit;
	}
	else { // all others too -> recursively
		dg->vmask=i;
		xorit=dg->connected;
		if (vectors<max_vectors)
		getInSet(dg->inwires[i],otval,dg,sval,dg);	
		dg->connected=xorit;
		if (dg->gTyp&~tNOT!=tXOR) break;
	  }
} else if ((nval!=vUndef)||(sval!=vUndef))  { 
	// i zde se muze vratit ihned vporadku, kvuli doprednemu nastaveni u fanu
	if (vectors<max_vectors) {
	if ((nval!=vUndef)&&(getBack!=NULL)) getInG2(getBack,0);
	if ((sval!=vUndef)&&(getsBack!=NULL)) getInG2(getsBack,1);
	if ((sval!=vUndef)&&(getsBack==NULL)) getToSet(dg->outwire,sval);
	if ((nval!=vUndef)&&(getBack==NULL)) getToSet(dg->outwire,nval);
	}
      }
		
} while (i>=0); // try next if possible

// not je potreba osetrit zvlast, musim vpred jiz zde
if ((dg->inputs==1)&&(succ==0)) {
	// cout << "not?" << endl;
   if (vectors<max_vectors)
	if ((bsval!=vUndef)) getToSet(dg->outwire,bsval);
}

dg->state=pUndef;
dg->value=vUndef;
dg->svalue=vUndef;
DBG_Cout("=getInG=:" << dg->name << endl);
} // else { cout << "value defined!" << endl; } // else  already defined
return 0;
}


int getInG2(DDGate *dg,int sens)  { // get againg to dg gate, success! continue...
DBG_Cout("getInG2:" << dg->name << " s:" << sens << endl);
int pomsv1,pomsv2; // sensitive values removed for this cycle
int otval=vUndef;
int otsval=vUndef;
int nval=dg->value;
int sval=dg->svalue;
int i=vUndef;
int vmaska=dg->vmask;
loops++;
if (kit>0) if (loops>kit) return 0;
DDWire *sw=dg->inwires[vmaska];
if (!sens) { // clear possible sens
	pomsv1=sw->svalue;
	sw->svalue=vUndef;
	if (sw->fromwire!=NULL) { 
		pomsv2=sw->fromwire->svalue;
		sw->fromwire->svalue=vUndef; 
	}
} // sens
DBG_Cout("ix:" << i << " nv:" << nval <<" ot:" <<otval << " sval" <<sval << " otsv:" << otsval << endl);
i=dg->getFreeInput(i,nval,otval,sval,otsval);
DBG_Cout("ix:" << i << " nv:" << nval <<" ot:" <<otval << " sval" <<sval << " otsv:" << otsval << endl);
if (i>=0) { 
	dg->vmask=i; 
	if (vectors<max_vectors)
	getInSet(dg->inwires[i],nval,dg,sval,dg);
}
else if ((nval>=0)||(sval>=0)) { // cannot be set, or set already, go back 
	if (vectors<max_vectors) {
	if (dg->backG!=NULL) getInG2(dg->backG,sens);
	else if (dg->svalue>=0) getToSet(dg->outwire,dg->svalue);
		else if (dg->value>=0) getToSet(dg->outwire,dg->value);
	}
} // or return...
DBG_Cout("=getInG2=" << dg->name << endl);

if (!sens) { // clear back possible sens
	sw->svalue=pomsv1;
	if (sw->fromwire!=NULL) sw->fromwire->svalue=pomsv2;
} // sens
return 0;
} // getInG2

int getInSet(DDWire *dw, int nval, DDGate *getBack,int sval, DDGate *getsBack) {
DBG_Cout("getInSet" << dw->name << endl);
// checks undefined value wires only 
dw->state=pOpen;
dw->value=nval;
dw->svalue=sval;
	if (dw->fromwire!=NULL) { // fan-out branch
		if (dw->fromwire->state==pUndef) // first time
		  getInSet(dw->fromwire,nval,getBack,sval,getsBack);
		else 
		if ((nval!=vUndef)&&(dw->fromwire->value==nval))  { //  val already defined 
		  if (getBack!=NULL) getInG2(getBack,0); // value ok
		}
		else if ((sval!=vUndef)&&(dw->fromwire->svalue==sval))  //  sval defined
		  if (getsBack!=NULL) getInG2(getsBack,1); // sensitive
	}
	else if (dw->fromgate!=NULL) {//  from gate
		getInG(dw->fromgate,nval,getBack,sval,getsBack);
	}
	else if (nval!=vUndef) { // PIN - no sens
		dw->svalue=vUndef;
		if (getBack!=NULL) getInG2(getBack,0); // value ok
	}
DBG_Cout("=getInSet=" << dw->name << endl);
dw->svalue=vUndef;
dw->value=vUndef;
dw->state=pUndef;
return 0;
}

// uz tady se musi rozhodnout - pokud prvni nastavuju
// vstupy, bude to pruchod typu vstupy nejdriv
	// ne - int x=getInSet(fw,NULL);
	// v tom pripade ale neni navrat NULL
	// ale dalsi hradlo v ceste:pokud je
	// bezprostredne za vodicem ale vetveni,
	// postupne vyberu vsechna hradla...
	// jenze pri volani zpatecni cesty, ne pred nim!
// -- uz mozna neni pravda --

int getToSet(DDWire *dw, int nval) {
DBG_Cout("getToSet" << dw->name <<" val:" << nval << endl);
if (dw->state==pUndef) { // not defined yet
dw->state=pOpen;
int x;
	if(dw->togate==NULL) {
	  if (dw->towires!=NULL) { // this is a fan
		if (dw->value==nval) { // this is not sens! then fan-out is...
			int iout=vUndef;
			for (int i=0; i<dw->outputs; i++)  // 
			if (dw->towires[i]->svalue==nval) iout=i;
			else 
				{ dw->towires[i]->value=nval; dw->towires[i]->state=pOpen; }
			/*
			for (int i=0;(i<dw->outputs);i++)
				if (dw->towires[i]->svalue==nval)
				{	
				*/
			if (iout!=vUndef) getToSet(dw->towires[iout],nval);
			/*
					break;
				}
				*/
			for (int i=0; i<dw->outputs; i++) 
			{ dw->towires[i]->value=vUndef; dw->towires[i]->state=pUndef; }
		} else { // fan is sens
		dw->svalue=nval; // sens fan-in 
		/* mozna by to usnadnilo pruchod 
		for (int i=0; i<dw->outputs; i++)  // 
		{ dw->towires[i]->svalue=nval; dw->towires[i]->state=pOpen; }
		 */ 
		// cout << "!!!!!" << dw->name << endl;
		for (int i=0; (i<dw->outputs)&&(vectors<max_vectors); i++) {
			x=getToSet(dw->towires[i],nval);
			if (x==1) break; 
		}
		/* mozna by to usnadnilo pruchod ? 
		for (int i=0; i<dw->outputs; i++) 
		{ dw->towires[i]->svalue=vUndef; dw->towires[i]->state=pUndef; }
	 	 */
		dw->svalue=vUndef;
		}
	  } else { // POUT!!! hit and write in/outs
		  mujobv->Simulate();
		  VECT[allvect++]=getInputs(mujobv);
		  vectors++;
		  cout << vectors << ":";
		 printInputs(mujobv);
		 cout << " ";
		 dw->value=nval;
		 printOutputs(mujobv);
		 cout << endl;
		 dw->value=vUndef;
		}
	} // to gate
	 else {
		 int sv=dw->svalue;
		 dw->svalue=nval;
		 // !!! musim spocitat jakou hodnotu budu mit po zcitliveni! ne nval!
		 if (dw->togate->gTyp&tNOT) nval=1-nval;
		 if ((dw->togate->gTyp&~tNOT)==tXOR) getInG(dw->togate,vUndef,NULL,1-nval,NULL);
		 getInG(dw->togate,vUndef,NULL,nval,NULL); // must be sensitive
		 dw->svalue=sv;
	 }
dw->state=pUndef;
DBG_Cout("=getToSet=" << dw->name <<" val:" << nval << endl);
} // else already defined
return 0;
}

// -------- test start --------
int makeTestX(DDFault *xff) {
DDWire *fw=xff->fw;
int x;
int nval=(xff->stuckAt==1)?0:1;
	// x=new logic4Set;
	vectors=0;
	loops=0;
	if (fw->fromgate!=NULL)
		x=getInG(fw->fromgate,nval,NULL,vUndef,NULL);
	else if (fw->fromwire!=NULL) {
		fw->svalue=nval;
		if (fw->fromwire->state==pUndef) {
			fw->fromwire->value=nval;
			if (fw->fromwire->fromgate!=NULL)
				x=getInG(fw->fromwire->fromgate,nval,NULL,vUndef,NULL);
			else getToSet(fw,nval);
			fw->svalue=vUndef;
			fw->fromwire->value=vUndef;
		} else x=0; //  { cout << "state!=undef" << endl; x=0; }
	} else getToSet(fw,nval); 
	// x=getToSet(fw,nval,NULL);
		 DBG_Cout("po pruchodu:");
		 DBG_DO(printInputs(mujobv));
		 DBG_Cout(" ");
		 DBG_DO(printOutputs(mujobv));
		 DBG_Cout(endl);
return x;
}

/**/

